/*
 * projetRobucar1103.c
 * 
 * Real-Time Workshop code generation for Simulink model "projetRobucar1103.mdl".
 *
 * Model Version              : 1.1168
 * Real-Time Workshop version : 6.4  (R2006a)  03-Feb-2006
 * C source code generated on : Mon Feb 18 20:07:47 2013
 */

#include "projetRobucar1103.h"
#include "projetRobucar1103_private.h"

/* Block signals (auto storage) */
BlockIO_projetRobucar1103 projetRobucar1103_B;

/* Continuous states */
ContinuousStates_projetRobucar1 projetRobucar1103_X;

/* Block states (auto storage) */
D_Work_projetRobucar1103 projetRobucar1103_DWork;

/* Real-time model */
RT_MODEL_projetRobucar1103 projetRobucar1103_M_;
RT_MODEL_projetRobucar1103 *projetRobucar1103_M = &projetRobucar1103_M_;

static void rate_scheduler(void);

/* This function implements a singletasking scheduler for a system with 3
 * rates.  This function is called by the generated step function, hence the
 * generated code self-manages all its subrates.
 */

static void rate_scheduler(void)
{

  /* Compute which subrates run during the next base time step.  Subrates
   * are an integer multiple of the base rate counter.  Therefore, the subtask
   * counter is reset when it reaches its limit (zero means run).
   */
  if (++projetRobucar1103_M->Timing.TaskCounters.TID[2] == 100) { /* Sample time: [0.1s, 0.0s] */
    projetRobucar1103_M->Timing.TaskCounters.TID[2] = 0;
  }
  projetRobucar1103_M->Timing.sampleHits[2] =
    (projetRobucar1103_M->Timing.TaskCounters.TID[2] == 0);
}

/* This function updates continuous states using the ODE1 fixed-step
 * solver algorithm
 */

static void rt_ertODEUpdateContinuousStates(RTWSolverInfo *si )
{
  time_T tnew = rtsiGetSolverStopTime(si);
  time_T h = rtsiGetStepSize(si);
  real_T *x = rtsiGetContStates(si);
  ODE1_IntgData *id = (ODE1_IntgData *)rtsiGetSolverData(si);
  real_T *f0 = id->f[0];
  int_T i;

  int_T nXc = 10;

  rtsiSetSimTimeStep(si,MINOR_TIME_STEP);

  rtsiSetdX(si, f0);
  projetRobucar1103_derivatives();
  rtsiSetT(si, tnew);

  for (i = 0; i < nXc; i++) {
    *x += h * f0[i];
    x++;
  }

  rtsiSetSimTimeStep(si,MAJOR_TIME_STEP);
}

/* Model output function */

void projetRobucar1103_output(int_T tid)
{

  /* Update absolute time of base rate at minor time step */
  if (rtmIsMinorTimeStep(projetRobucar1103_M)) {
    projetRobucar1103_M->Timing.t[0] =
      rtsiGetT(&projetRobucar1103_M->solverInfo);
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M)) {
    /* set solver stop time */
    rtsiSetSolverStopTime(&projetRobucar1103_M->solverInfo,
     ((projetRobucar1103_M->Timing.clockTick0+1)*projetRobucar1103_M->Timing.stepSize0));
  }                                     /* end MajorTimeStep */

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */

    /* Switch: '<S3>/Switch' incorporates:
     *  Constant: '<Root>/axe x'
     *  Constant: '<Root>/marche_arret'
     *  Constant: '<S3>/axe x_off'
     */
    if(projetRobucar1103_P.marche_arret_Value >=
     projetRobucar1103_P.Switch_Threshold) {
      projetRobucar1103_B.Switch = projetRobucar1103_P.axex_Value;
    } else {
      projetRobucar1103_B.Switch = projetRobucar1103_P.axex_off_Value;
    }

    /* Switch: '<S8>/Switch1' incorporates:
     *  Constant: '<Root>/axe y'
     *  Constant: '<Root>/frein manuel'
     *  Constant: '<Root>/marche_arret'
     *  Constant: '<Root>/mode manuel'
     *  Constant: '<S3>/axe y_off'
     */
    if(projetRobucar1103_P.modemanuel_Value >=
     projetRobucar1103_P.Switch1_Threshold) {

      /* Switch: '<S3>/Switch1' */
      if(projetRobucar1103_P.marche_arret_Value >=
       projetRobucar1103_P.Switch1_Threshold_e) {
        projetRobucar1103_B.Switch1_e = projetRobucar1103_P.axey_Value;
      } else {
        projetRobucar1103_B.Switch1_e = projetRobucar1103_P.axey_off_Value;
      }
      projetRobucar1103_B.Switch1 = projetRobucar1103_B.Switch1_e;
    } else {
      projetRobucar1103_B.Switch1 = projetRobucar1103_P.freinmanuel_Value;
    }

    /* Switch: '<S8>/Switch2' incorporates:
     *  Constant: '<Root>/axe z'
     *  Constant: '<Root>/consigne traction manuel'
     *  Constant: '<Root>/marche_arret'
     *  Constant: '<Root>/mode manuel'
     *  Constant: '<S3>/axe z_off'
     */
    if(projetRobucar1103_P.modemanuel_Value >=
     projetRobucar1103_P.Switch2_Threshold) {

      /* Switch: '<S3>/Switch2' */
      if(projetRobucar1103_P.marche_arret_Value >=
       projetRobucar1103_P.Switch2_Threshold_m) {
        projetRobucar1103_B.Switch2_n = projetRobucar1103_P.axez_Value;
      } else {
        projetRobucar1103_B.Switch2_n = projetRobucar1103_P.axez_off_Value;
      }
      projetRobucar1103_B.Switch2 = projetRobucar1103_B.Switch2_n;
    } else {
      projetRobucar1103_B.Switch2 = projetRobucar1103_P.consignetractionmanuel_V;
    }

    /* Switch: '<S3>/Switch3' incorporates:
     *  Constant: '<Root>/marche_arret'
     *  Constant: '<Root>/rapport vitesse'
     *  Constant: '<S3>/rapport vitesse_off'
     */
    if(projetRobucar1103_P.marche_arret_Value >=
     projetRobucar1103_P.Switch3_Threshold) {
      projetRobucar1103_B.Switch3 = projetRobucar1103_P.rapportvitesse_Value;
    } else {
      projetRobucar1103_B.Switch3 = projetRobucar1103_P.rapportvitesse_off_Value;
    }

    /* Switch: '<S8>/Switch3' incorporates:
     *  Constant: '<Root>/mode manuel'
     *  Constant: '<Root>/rapport manuel'
     */
    if(projetRobucar1103_P.modemanuel_Value >=
     projetRobucar1103_P.Switch3_Threshold_d) {
      projetRobucar1103_B.Switch3_i = projetRobucar1103_B.Switch3;
    } else {
      projetRobucar1103_B.Switch3_i = projetRobucar1103_P.rapportmanuel_Value;
    }
  }

  /* DataStoreRead: '<S8>/Data Store Read2' */
  projetRobucar1103_B.DataStoreRead2 = projetRobucar1103_DWork.pedal_frein;

  /* DataStoreRead: '<S8>/Data Store Read3' */
  projetRobucar1103_B.DataStoreRead3 = projetRobucar1103_DWork.consigne;

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* Gain: '<S48>/Gain' */
    projetRobucar1103_B.Gain = projetRobucar1103_B.SFunction1 *
      projetRobucar1103_P.Gain_Gain;
  }
  /* Derivative Block: '<S48>/Derivative' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative = (projetRobucar1103_B.Gain - *lastBank++)
        / deltaT;
    }
  }

  /* Gain: '<S48>/Gain2' */
  projetRobucar1103_B.Gain2 = projetRobucar1103_B.Derivative *
    projetRobucar1103_P.Gain2_Gain;

  /* Abs: '<S28>/Abs' */
  projetRobucar1103_B.Abs = fabs(projetRobucar1103_B.Gain2);

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* Gain: '<S48>/Gain1' */
    projetRobucar1103_B.Gain1 = projetRobucar1103_B.SFunction1_d *
      projetRobucar1103_P.Gain1_Gain;
  }
  /* Derivative Block: '<S48>/Derivative1' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative1_RWORK.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative1_RWORK.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative1 = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative1_RWORK.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative1 = (projetRobucar1103_B.Gain1 -
        *lastBank++) / deltaT;
    }
  }

  /* Gain: '<S48>/Gain3' */
  projetRobucar1103_B.Gain3 = projetRobucar1103_B.Derivative1 *
    projetRobucar1103_P.Gain3_Gain;

  /* Abs: '<S28>/Abs1' */
  projetRobucar1103_B.Abs1 = fabs(projetRobucar1103_B.Gain3);

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* Gain: '<S48>/Gain4' */
    projetRobucar1103_B.Gain4 = projetRobucar1103_B.SFunction1_g *
      projetRobucar1103_P.Gain4_Gain;
  }
  /* Derivative Block: '<S48>/Derivative2' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative2_RWORK.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative2_RWORK.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative2 = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative2_RWORK.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative2 = (projetRobucar1103_B.Gain4 -
        *lastBank++) / deltaT;
    }
  }

  /* Gain: '<S48>/Gain6' */
  projetRobucar1103_B.Gain6 = projetRobucar1103_B.Derivative2 *
    projetRobucar1103_P.Gain6_Gain;

  /* Abs: '<S28>/Abs2' */
  projetRobucar1103_B.Abs2 = fabs(projetRobucar1103_B.Gain6);

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* Gain: '<S48>/Gain5' */
    projetRobucar1103_B.Gain5 = projetRobucar1103_B.SFunction1_o *
      projetRobucar1103_P.Gain5_Gain;
  }
  /* Derivative Block: '<S48>/Derivative3' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative3_RWORK.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative3_RWORK.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative3 = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative3_RWORK.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative3 = (projetRobucar1103_B.Gain5 -
        *lastBank++) / deltaT;
    }
  }

  /* Gain: '<S48>/Gain7' */
  projetRobucar1103_B.Gain7 = projetRobucar1103_B.Derivative3 *
    projetRobucar1103_P.Gain7_Gain;

  /* Abs: '<S28>/Abs3' */
  projetRobucar1103_B.Abs3 = fabs(projetRobucar1103_B.Gain7);

  /* Sum: '<S28>/Add' */
  projetRobucar1103_B.Add = ((projetRobucar1103_B.Abs +
    projetRobucar1103_B.Abs1) + projetRobucar1103_B.Abs2) +
    projetRobucar1103_B.Abs3;

  /* Gain: '<S28>/Gain' */
  projetRobucar1103_B.Gain_i = projetRobucar1103_B.Add *
    projetRobucar1103_P.Gain_Gain_e;

  /* Embedded MATLAB Block: '<S8>/Gestion feinage'
   */

  {
    real_T eml_consigne_s;
    real_T eml_consigne;
    real_T eml_consigne_mes;
    real_T eml_pedal_acc;
    real_T eml_pedal_frein;
    int32_T eml_reset_repere;
    eml_consigne_s = projetRobucar1103_B.DataStoreRead3;
    /*  This block supports an embeddable subset of the MATLAB language. */
    /*  See the help menu for details.  */
    eml_consigne = 0.0;
    eml_consigne_mes = projetRobucar1103_B.Gain_i * 25.0;
    eml_pedal_acc = -0.5 * projetRobucar1103_B.Switch2 + 50.0;
    eml_pedal_frein = -0.5 * projetRobucar1103_B.Switch1 + 50.0;
    if(projetRobucar1103_B.Switch == 0.0) {
      eml_reset_repere = 1;
    } else {
      eml_reset_repere = 0;
    }
    if(eml_pedal_frein == 0.0) {
      if(projetRobucar1103_B.Switch3_i == 0.0) {
        /* consigne_angle_direction = 4512 - 5.15*axe_x; */
        /* alpha1=0;   % a calculer  partir de consigne_angle_direction (convertion -> rad ou  ) */
        /* alpha2=0;   % a calculer  partir de consigne_angle_direction (convertion -> rad ou  ) */
        /* A1 = [R/4*cos(alpha1), R/4*sin(alpha1), 1; R/4*cos(alpha1), R/4*sin(alpha1), R*(cos(alpha1)/(2*c) + sin(alpha1)/(a+b)); R/4*cos(alpha2), R/4*sin(alpha2), R*(cos(alpha2)/(2*c) + sin(alpha2)/(a+b)); R/4*cos(alpha2), R/4*sin(alpha2), -R*(cos(alpha2)/(2*c) + sin(alpha2)/(a+b))] */
        /* A = A1'; */
        /* V = [;0] ; */
        /* [Q,R]=qr(A); */
        /* Xs=R\(Q'*V) */
        /* tetapt1=Xs[1]; */
        /* tetapt2=Xs[2]; */
        /* tetapt3=Xs[3]; */
        /* tetapt4=Xs[4]; */
        eml_consigne = 0.0;
        eml_consigne_s = 0.0;
      }
      if(projetRobucar1103_B.Switch3_i == 1.0) {
        if(eml_pedal_acc == 0.0) {
          eml_consigne = eml_consigne_s;
        } else {
          eml_consigne = eml_pedal_acc * 0.2;
          eml_consigne_s = eml_consigne;
        }
      }
      if(projetRobucar1103_B.Switch3_i == 2.0) {
        if((eml_pedal_acc == 0.0) || (eml_consigne_s < 15.0)) {
          eml_consigne = eml_consigne_s;
        } else {
          eml_consigne = 20.0 + eml_pedal_acc * 0.19;
          eml_consigne_s = eml_consigne;
        }
      }
      if(projetRobucar1103_B.Switch3_i == 3.0) {
        if((eml_pedal_acc == 0.0) || (eml_consigne_s < 39.0)) {
          eml_consigne = eml_consigne_s;
        } else {
          eml_consigne = 44.0 + eml_pedal_acc * 0.19;
          eml_consigne_s = eml_consigne;
        }
      }
      if(projetRobucar1103_B.Switch3_i == 4.0) {
        if((eml_pedal_acc == 0.0) || (eml_consigne_s < 58.0)) {
          eml_consigne = eml_consigne_s;
        } else {
          eml_consigne = 63.0 + eml_pedal_acc * 0.25;
          eml_consigne_s = eml_consigne;
        }
      }
      if(projetRobucar1103_B.Switch3_i == 5.0) {
        if((eml_pedal_acc == 0.0) || (eml_consigne_s < 77.0)) {
          eml_consigne = eml_consigne_s;
        } else {
          eml_consigne = 82.0 + eml_pedal_acc * 0.25;
        }
      }
    } else if(eml_pedal_frein > 0.0) {
      if(!(eml_consigne_mes * (1.0 - eml_pedal_frein * 0.1) < 0.0)) {
        eml_consigne = eml_consigne_mes * (1.0 - eml_pedal_frein * 0.1);
      }
    } else {
      eml_consigne = projetRobucar1103_B.DataStoreRead3;
    }
    projetRobucar1103_B.consigne = eml_consigne;
    projetRobucar1103_B.pedal_frein = eml_pedal_frein;
    projetRobucar1103_B.reset_repere = (real_T)eml_reset_repere;
  }

  /* DataStoreWrite: '<S8>/Data Store Write' */
  projetRobucar1103_DWork.consigne = projetRobucar1103_B.consigne;

  /* DataStoreRead: '<S8>/Data Store Read1' */
  projetRobucar1103_B.DataStoreRead1 = projetRobucar1103_DWork.marche_arriere;

  /* Embedded MATLAB Block: '<S8>/Gestion marche arriere'
   */

  {
    real_T eml_marche_arriere;
    /*  This block supports an embeddable subset of the MATLAB language. */
    /*  See the help menu for details.  */
    eml_marche_arriere = projetRobucar1103_B.DataStoreRead1;
    if((projetRobucar1103_P.M_AvAr_Value == 0.0) && (projetRobucar1103_B.Switch3
      == 0.0)) {
      eml_marche_arriere = 0.0;
    } else if((projetRobucar1103_P.M_AvAr_Value == 1.0) &&
     (projetRobucar1103_B.Switch3 == 0.0)) {
      eml_marche_arriere = 1.0;
    }
    projetRobucar1103_B.marche_arriere = eml_marche_arriere;
  }

  /* DataStoreWrite: '<S8>/Data Store Write1' */
  projetRobucar1103_DWork.marche_arriere = projetRobucar1103_B.marche_arriere;

  /* DataStoreWrite: '<S8>/Data Store Write2' */
  projetRobucar1103_DWork.pedal_frein = projetRobucar1103_B.pedal_frein;

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* Gain: '<S26>/Gain' */
    projetRobucar1103_B.Gain_j =
      (uint16_T)((uint32_T)projetRobucar1103_B.SFunction1_o1_g[1] *
      (uint32_T)projetRobucar1103_P.Gain_Gain_d);

    /* Sum: '<S26>/Sum' */
    projetRobucar1103_B.Sum_e =
      (uint16_T)((uint32_T)(uint16_T)(projetRobucar1103_B.SFunction1_o1_g[0] >>
      1) + (uint32_T)projetRobucar1103_B.Gain_j);

    /* Sum: '<S26>/Sum1' incorporates:
     *  Constant: '<S26>/Constant1'
     */
    projetRobucar1103_B.Sum1 = ldexp((real_T)projetRobucar1103_B.Sum_e, 1) -
    projetRobucar1103_P.Constant1_Value;

    /* Sum: '<S26>/Sum2' incorporates:
     *  Constant: '<S26>/Constant'
     */
    projetRobucar1103_B.Sum2 = (real_T)projetRobucar1103_B.SFunction1_o1_g[1] -
      projetRobucar1103_P.Constant_Value;

    /* RelationalOperator: '<S32>/Compare' incorporates:
     *  Constant: '<S32>/Constant'
     */
    projetRobucar1103_B.Compare = (projetRobucar1103_B.Sum2 >=
      projetRobucar1103_P.Constant_Value_b);
  }

  /* DataStoreRead: '<S26>/Data Store Read2' */
  projetRobucar1103_B.DataStoreRead2_l =
    projetRobucar1103_DWork.position_verin_Av;

  /* Switch: '<S26>/Switch' */
  if(projetRobucar1103_B.Compare >= projetRobucar1103_P.Switch_Threshold_m) {
    projetRobucar1103_B.Switch_k = projetRobucar1103_B.Sum1;
  } else {
    projetRobucar1103_B.Switch_k = projetRobucar1103_B.DataStoreRead2_l;
  }

  /* DataStoreWrite: '<S26>/Data Store Write1' */
  projetRobucar1103_DWork.position_verin_Av = projetRobucar1103_B.Switch_k;

  /* DataStoreRead: '<S26>/Data Store Read1' */
  projetRobucar1103_B.DataStoreRead1_g =
    projetRobucar1103_DWork.position_verin_Ar;

  /* Switch: '<S26>/Switch1' */
  if(projetRobucar1103_B.Compare >= projetRobucar1103_P.Switch1_Threshold_g) {
    projetRobucar1103_B.Switch1_k = projetRobucar1103_B.DataStoreRead1_g;
  } else {
    projetRobucar1103_B.Switch1_k = projetRobucar1103_B.Sum_e;
  }

  /* DataStoreWrite: '<S26>/Data Store Write2' */
  projetRobucar1103_DWork.position_verin_Ar = projetRobucar1103_B.Switch1_k;

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */
  }

  if(rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) {

    /* Embedded MATLAB Block: '<S8>/Gestion modes direction'
     */

    {
      real_T eml_axe_x_Av;
      real_T eml_axe_x_Ar;
      /*  This block supports an embeddable subset of the MATLAB language. */
      /*  See the help menu for details.  */
      eml_axe_x_Av = projetRobucar1103_B.Switch;
      eml_axe_x_Ar = projetRobucar1103_B.Switch;
      if(projetRobucar1103_P.mode_direction_Value == 0.0) {
        /*  mode les deux */
        eml_axe_x_Av = projetRobucar1103_B.Switch;
        eml_axe_x_Ar = projetRobucar1103_B.Switch * -1.0;
      }
      if(projetRobucar1103_P.mode_direction_Value == 1.0) {
        /*  mode avant seule */
        eml_axe_x_Av = projetRobucar1103_B.Switch;
        eml_axe_x_Ar = 0.0;
      }
      if(projetRobucar1103_P.mode_direction_Value == 2.0) {
        /*  mode arriere seule */
        eml_axe_x_Av = 0.0;
        eml_axe_x_Ar = projetRobucar1103_B.Switch;
      }
      if(projetRobucar1103_P.mode_direction_Value == 3.0) {
        /*  mode park */
        eml_axe_x_Av = projetRobucar1103_B.Switch;
        eml_axe_x_Ar = projetRobucar1103_B.Switch;
      }
      projetRobucar1103_B.axe_x_Av = eml_axe_x_Av;
      projetRobucar1103_B.axe_x_Ar = eml_axe_x_Ar;
    }

    /* Embedded MATLAB Block: '<S27>/strategie commande alpha1'
     */
    /*  This block supports an embeddable subset of the MATLAB language. */
    /*  See the help menu for details.  */
    projetRobucar1103_B.y_o = 4512.0 + 5.15 * projetRobucar1103_B.axe_x_Ar;
  }

  {
    real_T tmp;

    /* Sum: '<S27>/Sum' */
    projetRobucar1103_B.Sum = projetRobucar1103_B.y_o -
      projetRobucar1103_B.Switch_k;

    /* DataTypeConversion: '<S35>/Data Type Conversion' */
    tmp = fmod(floor(projetRobucar1103_B.Switch_k), 4.294967296E+009);
    if(tmp < -2.147483648E+009) {
      tmp += 4.294967296E+009;
    } else if(tmp >= 2.147483648E+009) {
      tmp -= 4.294967296E+009;
    }
    projetRobucar1103_B.DataTypeConversion = (int32_T)tmp;
  }

  /* Clock Block: '<S35>/Clock'
   */
  projetRobucar1103_B.Clock = projetRobucar1103_M->Timing.t[0];

  /* TransportDelay Block: '<S35>/Transport Delay' */
  {

    real_T **uBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay_PWORK.TUbufferPtrs[0];
    real_T **tBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay_PWORK.TUbufferPtrs[1];
    real_T simTime = projetRobucar1103_M->Timing.t[0];

    real_T tMinusDelay = simTime - projetRobucar1103_P.TransportDelay_Delay;

    projetRobucar1103_B.TransportDelay = rt_TDelayInterpolate(
      tMinusDelay,
     0.0,
     *tBuffer,
     *uBuffer,
     projetRobucar1103_DWork.TransportDelay_IWORK.CircularBufSize,
     &projetRobucar1103_DWork.TransportDelay_IWORK.Last,
     projetRobucar1103_DWork.TransportDelay_IWORK.Tail,
     projetRobucar1103_DWork.TransportDelay_IWORK.Head,
     projetRobucar1103_P.TransportDelay_InitOutput,
     0,
     0);
  }

  /* TransportDelay Block: '<S35>/Transport Delay1' */
  {

    real_T **uBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay1_PWORK.TUbufferPtrs[0];
    real_T **tBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay1_PWORK.TUbufferPtrs[1];
    real_T simTime = projetRobucar1103_M->Timing.t[0];

    real_T tMinusDelay = simTime - projetRobucar1103_P.TransportDelay1_Delay;

    projetRobucar1103_B.TransportDelay1 = rt_TDelayInterpolate(
      tMinusDelay,
     0.0,
     *tBuffer,
     *uBuffer,
     projetRobucar1103_DWork.TransportDelay1_IWORK.CircularBufSize,
     &projetRobucar1103_DWork.TransportDelay1_IWORK.Last,
     projetRobucar1103_DWork.TransportDelay1_IWORK.Tail,
     projetRobucar1103_DWork.TransportDelay1_IWORK.Head,
     projetRobucar1103_P.TransportDelay1_InitOutpu,
     0,
     0);
  }

  {
    real_T tmp;

    /* DataTypeConversion: '<S35>/Data Type Conversion2' */
    tmp = fmod(floor(projetRobucar1103_B.TransportDelay1), 4.294967296E+009);
    if(tmp < -2.147483648E+009) {
      tmp += 4.294967296E+009;
    } else if(tmp >= 2.147483648E+009) {
      tmp -= 4.294967296E+009;
    }
    projetRobucar1103_B.DataTypeConversion2 = (int32_T)tmp;

    /* Embedded MATLAB Block: '<S35>/Embedded MATLAB Function'
     */

    {
      real_T eml_e_pid;
      int32_T eml_inhibit;
      int32_T eml_codeur_w;
      real_T eml_e_w;
      /*  This block supports an embeddable subset of the MATLAB language. */
      /*  See the help menu for details.  */
      if(projetRobucar1103_B.Clock < 5.0) {
        eml_e_pid = 0.0;
        eml_inhibit = 1;
        /*  on attend 5 sec afin d'avoir les bonnes valeurs du codeur abs */
        eml_codeur_w = projetRobucar1103_B.DataTypeConversion;
        eml_e_w = projetRobucar1103_B.Sum;
      } else if((projetRobucar1103_B.DataTypeConversion < 3900) ||
       (projetRobucar1103_B.DataTypeConversion > 5120) ||
       (fabs(projetRobucar1103_B.Sum) < 5.0) ||
       ((projetRobucar1103_B.TransportDelay != projetRobucar1103_B.Sum) &&
        (projetRobucar1103_B.DataTypeConversion2 ==
         projetRobucar1103_B.DataTypeConversion))) {
        /*  si le robucar tait teint (valeurs codeur fausses)  */
        /*  ou on est trs proche de la consigne  */
        /*  ou arduino dbranch (codeur abs non connect)          */
        eml_e_pid = 0.0;
        eml_inhibit = 1;
        /*  on arrte la commande de la direction en boucle ferme  */
        eml_codeur_w = projetRobucar1103_B.DataTypeConversion;
        eml_e_w = projetRobucar1103_B.Sum;
      } else {
        eml_e_pid = projetRobucar1103_B.Sum;
        eml_inhibit = 0;
        /*  commande de la direction en BF */
        eml_codeur_w = projetRobucar1103_B.DataTypeConversion;
        eml_e_w = projetRobucar1103_B.Sum;
      }
      projetRobucar1103_B.e_pid_g = eml_e_pid;
      projetRobucar1103_B.inhibit_e = (real_T)eml_inhibit;
      projetRobucar1103_B.e_w_i = eml_e_w;
      projetRobucar1103_B.codeur_w_g = eml_codeur_w;
    }

    /* Gain: '<S37>/Proportional' */
    projetRobucar1103_B.Proportional = projetRobucar1103_B.e_pid_g *
      projetRobucar1103_P.Proportional_Gain;
  }

  /* TransferFcn Block: '<S37>/Integral' */
  projetRobucar1103_B.Integral =
    projetRobucar1103_P.Integral_C*projetRobucar1103_X.Integral_CSTATE;

  /* Gain: '<S37>/D' */
  projetRobucar1103_B.D = projetRobucar1103_B.e_pid_g *
    projetRobucar1103_P.D_Gain;

  /* Derivative Block: '<S37>/Derivative' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_c.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_c.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative_n = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_c.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative_n = (projetRobucar1103_B.D - *lastBank++) /
        deltaT;
    }
  }

  /* Sum: '<S37>/Sum' */
  projetRobucar1103_B.Sum_f = (projetRobucar1103_B.Proportional +
    projetRobucar1103_B.Integral) + projetRobucar1103_B.Derivative_n;

  /* Embedded MATLAB Block: '<S27>/strategie commande alpha'
   */

  {
    real_T eml_y;
    int32_T eml_direction;
    /*  This block supports an embeddable subset of the MATLAB language. */
    /*  See the help menu for details.  */
    eml_y = fabs(projetRobucar1103_B.Sum_f / 2575.0);
    if(projetRobucar1103_B.Sum_f < 0.0) {
      eml_direction = 1;
    } else {
      eml_direction = 2;
    }
    projetRobucar1103_B.alpha = eml_y;
    projetRobucar1103_B.direction = (real_T)eml_direction;
  }

  /* Switch: '<S27>/Switch1' incorporates:
   *  Constant: '<Root>/direction manuel Ar'
   *  Constant: '<Root>/mode manuel'
   *  Constant: '<S27>/bin 0'
   *  Constant: '<S27>/bin 1'
   */
  if(projetRobucar1103_P.modemanuel_Value >=
   projetRobucar1103_P.Switch1_Threshold_h) {

    /* Switch: '<S27>/Switch' */
    if(projetRobucar1103_B.direction >= projetRobucar1103_P.Switch_Threshold_h) {
      projetRobucar1103_B.Switch_e = projetRobucar1103_P.bin1_Value;
    } else {
      projetRobucar1103_B.Switch_e = projetRobucar1103_P.bin0_Value;
    }
    projetRobucar1103_B.Switch1_l = projetRobucar1103_B.Switch_e;
  } else {
    projetRobucar1103_B.Switch1_l = projetRobucar1103_P.directionmanuelAr_Value;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */

    /* Embedded MATLAB Block: '<S27>/strategie commande alpha3'
     */
    /*  This block supports an embeddable subset of the MATLAB language. */
    /*  See the help menu for details.  */
    projetRobucar1103_B.y = 1890.0 + 4.85 * projetRobucar1103_B.axe_x_Av;
  }

  /* Sum: '<S27>/Sum1' */
  projetRobucar1103_B.Sum1_b = projetRobucar1103_B.y -
    ldexp((real_T)projetRobucar1103_B.Switch1_k, 1);

  /* DataTypeConversion: '<S36>/Data Type Conversion' */
  projetRobucar1103_B.DataTypeConversion_c = projetRobucar1103_B.Switch1_k << 1U;

  /* Clock Block: '<S36>/Clock'
   */
  projetRobucar1103_B.Clock_g = projetRobucar1103_M->Timing.t[0];

  /* TransportDelay Block: '<S36>/Transport Delay' */
  {

    real_T **uBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay_PWORK_c.TUbufferPtrs[0];
    real_T **tBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay_PWORK_c.TUbufferPtrs[1];
    real_T simTime = projetRobucar1103_M->Timing.t[0];

    real_T tMinusDelay = simTime - projetRobucar1103_P.TransportDelay_Delay_c;

    projetRobucar1103_B.TransportDelay_l = rt_TDelayInterpolate(
      tMinusDelay,
     0.0,
     *tBuffer,
     *uBuffer,
     projetRobucar1103_DWork.TransportDelay_IWORK_n.CircularBufSize,
     &projetRobucar1103_DWork.TransportDelay_IWORK_n.Last,
     projetRobucar1103_DWork.TransportDelay_IWORK_n.Tail,
     projetRobucar1103_DWork.TransportDelay_IWORK_n.Head,
     projetRobucar1103_P.TransportDelay_InitOutp_p,
     0,
     0);
  }

  /* TransportDelay Block: '<S36>/Transport Delay1' */
  {

    real_T **uBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay1_PWORK_a.TUbufferPtrs[0];
    real_T **tBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay1_PWORK_a.TUbufferPtrs[1];
    real_T simTime = projetRobucar1103_M->Timing.t[0];

    real_T tMinusDelay = simTime - projetRobucar1103_P.TransportDelay1_Delay_k;

    projetRobucar1103_B.TransportDelay1_j = rt_TDelayInterpolate(
      tMinusDelay,
     0.0,
     *tBuffer,
     *uBuffer,
     projetRobucar1103_DWork.TransportDelay1_IWORK_k.CircularBufSize,
     &projetRobucar1103_DWork.TransportDelay1_IWORK_k.Last,
     projetRobucar1103_DWork.TransportDelay1_IWORK_k.Tail,
     projetRobucar1103_DWork.TransportDelay1_IWORK_k.Head,
     projetRobucar1103_P.TransportDelay1_InitOut_e,
     0,
     0);
  }

  {
    real_T tmp;

    /* DataTypeConversion: '<S36>/Data Type Conversion2' */
    tmp = fmod(floor(projetRobucar1103_B.TransportDelay1_j), 4.294967296E+009);
    if(tmp < -2.147483648E+009) {
      tmp += 4.294967296E+009;
    } else if(tmp >= 2.147483648E+009) {
      tmp -= 4.294967296E+009;
    }
    projetRobucar1103_B.DataTypeConversion2_a = (int32_T)tmp;

    /* Embedded MATLAB Block: '<S36>/Embedded MATLAB Function'
     */

    {
      real_T eml_e_pid;
      int32_T eml_inhibit;
      int32_T eml_codeur_w;
      real_T eml_e_w;
      /*  This block supports an embeddable subset of the MATLAB language. */
      /*  See the help menu for details.  */
      if(projetRobucar1103_B.Clock_g < 5.0) {
        eml_e_pid = 0.0;
        eml_inhibit = 1;
        /*  on attend 5 sec afin d'avoir les bonnes valeurs du codeur abs */
        eml_codeur_w = projetRobucar1103_B.DataTypeConversion_c;
        eml_e_w = projetRobucar1103_B.Sum1_b;
      } else if((projetRobucar1103_B.DataTypeConversion_c < 1350) ||
       (projetRobucar1103_B.DataTypeConversion_c > 2415) ||
       (fabs(projetRobucar1103_B.Sum1_b) < 5.0) ||
       ((projetRobucar1103_B.TransportDelay_l != projetRobucar1103_B.Sum1_b) &&
        (projetRobucar1103_B.DataTypeConversion2_a ==
         projetRobucar1103_B.DataTypeConversion_c))) {
        /*  si le robucar tait teint (valeurs codeur fausses)  */
        /*  ou on est trs proche de la consigne  */
        /*  ou arduino dbranch (codeur abs non connect)          */
        eml_e_pid = 0.0;
        eml_inhibit = 1;
        /*  on arrte la commande de la direction en boucle ferme  */
        eml_codeur_w = projetRobucar1103_B.DataTypeConversion_c;
        eml_e_w = projetRobucar1103_B.Sum1_b;
      } else {
        eml_e_pid = projetRobucar1103_B.Sum1_b;
        eml_inhibit = 0;
        /*  commande de la direction en BF */
        eml_codeur_w = projetRobucar1103_B.DataTypeConversion_c;
        eml_e_w = projetRobucar1103_B.Sum1_b;
      }
      projetRobucar1103_B.e_pid = eml_e_pid;
      projetRobucar1103_B.inhibit = (real_T)eml_inhibit;
      projetRobucar1103_B.e_w = eml_e_w;
      projetRobucar1103_B.codeur_w = eml_codeur_w;
    }

    /* Gain: '<S38>/Proportional' */
    projetRobucar1103_B.Proportional_m = projetRobucar1103_B.e_pid *
      projetRobucar1103_P.Proportional_Gain_e;
  }

  /* TransferFcn Block: '<S38>/Integral' */
  projetRobucar1103_B.Integral_k =
    projetRobucar1103_P.Integral_C_k*projetRobucar1103_X.Integral_j_CSTATE;

  /* Gain: '<S38>/D' */
  projetRobucar1103_B.D_j = projetRobucar1103_B.e_pid *
    projetRobucar1103_P.D_Gain_g;

  /* Derivative Block: '<S38>/Derivative' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_i.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_i.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative_f = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_i.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative_f = (projetRobucar1103_B.D_j - *lastBank++)
        / deltaT;
    }
  }

  /* Sum: '<S38>/Sum' */
  projetRobucar1103_B.Sum_m = (projetRobucar1103_B.Proportional_m +
    projetRobucar1103_B.Integral_k) + projetRobucar1103_B.Derivative_f;

  /* Embedded MATLAB Block: '<S27>/strategie commande  alpha'
   */

  {
    real_T eml_y;
    int32_T eml_direction;
    /*  This block supports an embeddable subset of the MATLAB language. */
    /*  See the help menu for details.  */
    eml_y = fabs(projetRobucar1103_B.Sum_m / 3150.0);
    if(projetRobucar1103_B.Sum_m < 0.0) {
      eml_direction = 2;
    } else {
      eml_direction = 1;
    }
    projetRobucar1103_B.alpha_n = eml_y;
    projetRobucar1103_B.direction_n = (real_T)eml_direction;
  }

  /* Switch: '<S27>/Switch5' incorporates:
   *  Constant: '<Root>/direction manuel Av'
   *  Constant: '<Root>/mode manuel'
   *  Constant: '<S27>/bin 2'
   *  Constant: '<S27>/bin 3'
   */
  if(projetRobucar1103_P.modemanuel_Value >=
   projetRobucar1103_P.Switch5_Threshold) {

    /* Switch: '<S27>/Switch4' */
    if(projetRobucar1103_B.direction_n >= projetRobucar1103_P.Switch4_Threshold)
    {
      projetRobucar1103_B.Switch4 = projetRobucar1103_P.bin3_Value;
    } else {
      projetRobucar1103_B.Switch4 = projetRobucar1103_P.bin2_Value;
    }
    projetRobucar1103_B.Switch5 = projetRobucar1103_B.Switch4;
  } else {
    projetRobucar1103_B.Switch5 = projetRobucar1103_P.directionmanuelAv_Value;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* dSPACE I/O Board DS1103 #1 Unit:BIT_IO Group:BIT_OUT */
    if (projetRobucar1103_B.Switch1_l > 0){
      ds1103_bit_io_set(DS1103_DIO0_SET);}
    else{
      ds1103_bit_io_clear(DS1103_DIO0_CLEAR);}
  }

  /* Switch: '<S27>/Switch3' incorporates:
   *  Constant: '<Root>/inhibit manuel Ar'
   *  Constant: '<Root>/mode manuel'
   */
  if(projetRobucar1103_P.modemanuel_Value >=
   projetRobucar1103_P.Switch3_Threshold_l) {
    projetRobucar1103_B.Switch3_g = projetRobucar1103_B.inhibit_e;
  } else {
    projetRobucar1103_B.Switch3_g = projetRobucar1103_P.inhibitmanuelAr_Value;
  }

  /* DataTypeConversion: '<S39>/Data Type Conversion' */
  projetRobucar1103_B.DataTypeConversion_p =
    (boolean_T)(projetRobucar1103_B.Switch3_g != 0.0 ? 1U : 0U);

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* dSPACE I/O Board DS1103 #1 Unit:BIT_IO Group:BIT_OUT */
    if (projetRobucar1103_B.DataTypeConversion_p > 0){
      ds1103_bit_io_set(DS1103_DIO1_SET);}
    else{
      ds1103_bit_io_clear(DS1103_DIO1_CLEAR);}

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* dSPACE I/O Board DS1103 #1 Unit:BIT_IO Group:BIT_OUT */
    if (projetRobucar1103_B.Switch5 > 0){
      ds1103_bit_io_set(DS1103_DIO4_SET);}
    else{
      ds1103_bit_io_clear(DS1103_DIO4_CLEAR);}
  }

  /* Switch: '<S27>/Switch7' incorporates:
   *  Constant: '<Root>/inhibit manuel Av'
   *  Constant: '<Root>/mode manuel'
   */
  if(projetRobucar1103_P.modemanuel_Value >=
   projetRobucar1103_P.Switch7_Threshold) {
    projetRobucar1103_B.Switch7 = projetRobucar1103_B.inhibit;
  } else {
    projetRobucar1103_B.Switch7 = projetRobucar1103_P.inhibitmanuelAv_Value;
  }

  /* DataTypeConversion: '<S39>/Data Type Conversion1' */
  projetRobucar1103_B.DataTypeConversion1_p =
    (boolean_T)(projetRobucar1103_B.Switch7 != 0.0 ? 1U : 0U);

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* dSPACE I/O Board DS1103 #1 Unit:BIT_IO Group:BIT_OUT */
    if (projetRobucar1103_B.DataTypeConversion1_p > 0){
      ds1103_bit_io_set(DS1103_DIO5_SET);}
    else{
      ds1103_bit_io_clear(DS1103_DIO5_CLEAR);}

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */
  }

  {
    real_T rtsaturate_U0DataInY0Container;

    /* Switch: '<S27>/Switch2' incorporates:
     *  Constant: '<Root>/mode manuel'
     *  Constant: '<Root>/rapport cycle manuel Ar'
     */
    if(projetRobucar1103_P.modemanuel_Value >=
     projetRobucar1103_P.Switch2_Threshold_d) {
      projetRobucar1103_B.Switch2_p = projetRobucar1103_B.alpha;
    } else {
      projetRobucar1103_B.Switch2_p =
        projetRobucar1103_P.rapportcyclemanuelAr_Va;
    }

    /* Saturate: '<S39>/Saturation rapport  cycle1' */
    rtsaturate_U0DataInY0Container = rt_SATURATE(projetRobucar1103_B.Switch2_p,
     projetRobucar1103_P.Saturationrapportcycl_c,
     projetRobucar1103_P.Saturationrapportcycle1);
    projetRobucar1103_B.Saturationrapportcycle1 = rtsaturate_U0DataInY0Container;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* dSPACE I/O Board DS1103 #1 Unit:PWM */

    projetRobucar1103_DWork.SFunction2_IWORK[1] = projetRobucar1103_B.Switch3_g;

    /* write the duty cycle down */
    ds1103_slave_dsp_pwm_duty_write(0, rti_slv1103_fcn_index[7],
     projetRobucar1103_B.Saturationrapportcycle1);
    /* set outputs to TTL-level or retrigger PWM generation */
    if ( projetRobucar1103_DWork.SFunction2_IWORK[1] == 1 )
    {
      /*  if (flag == RUN)||(flag == UNDEF) */
      if ((slaveDSPPwmStopFlagCh2 == 1)||(slaveDSPPwmStopFlagCh2 == 2))
      /* PWM Stop signal from Input Port -> set outputs to TTL-level */
      {
        slaveDSPPwmStopFlagCh2 = 0;
        ds1103_slave_dsp_pwm_output_set(0, SLVDSP1103_PWM_CH2_MSK,
         SLVDSP1103_PWM_TTL_HIGH);
      }
    }
    else if ( projetRobucar1103_DWork.SFunction2_IWORK[1] == 0 )
    {
      /* PWM Stop signal disabled -> trigger PWM generation once */
      if ((slaveDSPPwmStopFlagCh2 == 0)||(slaveDSPPwmStopFlagCh2 == 2))
      {
        slaveDSPPwmStopFlagCh2 = 1;
        ds1103_slave_dsp_pwm_start(0, SLVDSP1103_PWM_CH2_MSK);
      }
    }

    /* This comment workarounds a Real-Time Workshop code generation problem */
  }

  {
    real_T rtsaturate_U0DataInY0Container;

    /* Switch: '<S27>/Switch6' incorporates:
     *  Constant: '<Root>/mode manuel'
     *  Constant: '<Root>/rapport cycle manuel Av'
     */
    if(projetRobucar1103_P.modemanuel_Value >=
     projetRobucar1103_P.Switch6_Threshold) {
      projetRobucar1103_B.Switch6 = projetRobucar1103_B.alpha_n;
    } else {
      projetRobucar1103_B.Switch6 = projetRobucar1103_P.rapportcyclemanuelAv_Va;
    }

    /* Saturate: '<S39>/Saturation rapport  cycle' */
    rtsaturate_U0DataInY0Container = rt_SATURATE(projetRobucar1103_B.Switch6,
     projetRobucar1103_P.Saturationrapportcycl_i,
     projetRobucar1103_P.Saturationrapportcycle);
    projetRobucar1103_B.Saturationrapportcycle = rtsaturate_U0DataInY0Container;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* dSPACE I/O Board DS1103 #1 Unit:PWM */

    projetRobucar1103_DWork.SFunction4_IWORK[3] = projetRobucar1103_B.Switch7;

    /* write the duty cycle down */
    ds1103_slave_dsp_pwm_duty_write(0, rti_slv1103_fcn_index[9],
     projetRobucar1103_B.Saturationrapportcycle);
    /* set outputs to TTL-level or retrigger PWM generation */
    if ( projetRobucar1103_DWork.SFunction4_IWORK[3] == 1 )
    {
      /*  if (flag == RUN)||(flag == UNDEF) */
      if ((slaveDSPPwmStopFlagCh4 == 1)||(slaveDSPPwmStopFlagCh4 == 2))
      /* PWM Stop signal from Input Port -> set outputs to TTL-level */
      {
        slaveDSPPwmStopFlagCh4 = 0;
        ds1103_slave_dsp_pwm_output_set(0, SLVDSP1103_PWM_CH4_MSK,
         SLVDSP1103_PWM_TTL_LOW);
      }
    }
    else if ( projetRobucar1103_DWork.SFunction4_IWORK[3] == 0 )
    {
      /* PWM Stop signal disabled -> trigger PWM generation once */
      if ((slaveDSPPwmStopFlagCh4 == 0)||(slaveDSPPwmStopFlagCh4 == 2))
      {
        slaveDSPPwmStopFlagCh4 = 1;
        ds1103_slave_dsp_pwm_start(0, SLVDSP1103_PWM_CH4_MSK);
      }
    }
  }

  /* DataTypeConversion: '<S35>/Data Type Conversion1' */
  projetRobucar1103_B.DataTypeConversion1 =
    (real_T)projetRobucar1103_B.codeur_w_g;

  /* DataTypeConversion: '<S36>/Data Type Conversion1' */
  projetRobucar1103_B.DataTypeConversion1_m =
    (real_T)projetRobucar1103_B.codeur_w;

  /* Abs: '<S49>/Abs2' */
  projetRobucar1103_B.Abs2_e = fabs(projetRobucar1103_B.Gain6);

  /* Sum: '<S49>/Sum9' */
  projetRobucar1103_B.Sum9 = 0.0 - projetRobucar1103_B.Abs2_e;

  /* Gain: '<S62>/D' */
  projetRobucar1103_B.D_g = projetRobucar1103_B.Sum9 *
    projetRobucar1103_P.D_Gain_j;

  /* Derivative Block: '<S62>/Derivative' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_g.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_g.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative_p = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_g.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative_p = (projetRobucar1103_B.D_g - *lastBank++)
        / deltaT;
    }
  }

  /* TransferFcn Block: '<S62>/Integral' */
  projetRobucar1103_B.Integral_g =
    projetRobucar1103_P.Integral_C_o*projetRobucar1103_X.Integral_h_CSTATE;

  /* Gain: '<S62>/Proportional' */
  projetRobucar1103_B.Proportional_j = projetRobucar1103_B.Sum9 *
    projetRobucar1103_P.Proportional_Gain_f;

  /* Sum: '<S62>/Sum' */
  projetRobucar1103_B.Sum_a = (projetRobucar1103_B.Proportional_j +
    projetRobucar1103_B.Integral_g) + projetRobucar1103_B.Derivative_p;

  /* Abs: '<S49>/Abs1' */
  projetRobucar1103_B.Abs1_p = fabs(projetRobucar1103_B.Gain3);

  /* Sum: '<S49>/Sum5' */
  projetRobucar1103_B.Sum5 = 0.0 - projetRobucar1103_B.Abs1_p;

  /* Gain: '<S59>/D' */
  projetRobucar1103_B.D_c = projetRobucar1103_B.Sum5 *
    projetRobucar1103_P.D_Gain_k;

  /* Derivative Block: '<S59>/Derivative' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_f.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_f.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative_a = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_f.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative_a = (projetRobucar1103_B.D_c - *lastBank++)
        / deltaT;
    }
  }

  /* TransferFcn Block: '<S59>/Integral' */
  projetRobucar1103_B.Integral_c =
    projetRobucar1103_P.Integral_C_l*projetRobucar1103_X.Integral_e_CSTATE;

  /* Gain: '<S59>/Proportional' */
  projetRobucar1103_B.Proportional_j3 = projetRobucar1103_B.Sum5 *
    projetRobucar1103_P.Proportional_Gain_a;

  /* Sum: '<S59>/Sum' */
  projetRobucar1103_B.Sum_j = (projetRobucar1103_B.Proportional_j3 +
    projetRobucar1103_B.Integral_c) + projetRobucar1103_B.Derivative_a;

  /* Abs: '<S49>/Abs' */
  projetRobucar1103_B.Abs_m = fabs(projetRobucar1103_B.Gain2);

  /* Sum: '<S49>/Sum2' */
  projetRobucar1103_B.Sum2_b = 0.0 - projetRobucar1103_B.Abs_m;

  /* Gain: '<S60>/D' */
  projetRobucar1103_B.D_f = projetRobucar1103_B.Sum2_b *
    projetRobucar1103_P.D_Gain_o;

  /* Derivative Block: '<S60>/Derivative' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_d.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_d.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative_h = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_d.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative_h = (projetRobucar1103_B.D_f - *lastBank++)
        / deltaT;
    }
  }

  /* TransferFcn Block: '<S60>/Integral' */
  projetRobucar1103_B.Integral_d =
    projetRobucar1103_P.Integral_C_p*projetRobucar1103_X.Integral_c_CSTATE;

  /* Gain: '<S60>/Proportional' */
  projetRobucar1103_B.Proportional_d = projetRobucar1103_B.Sum2_b *
    projetRobucar1103_P.Proportional_Gain_k;

  /* Sum: '<S60>/Sum' */
  projetRobucar1103_B.Sum_m2 = (projetRobucar1103_B.Proportional_d +
    projetRobucar1103_B.Integral_d) + projetRobucar1103_B.Derivative_h;

  /* Abs: '<S49>/Abs3' */
  projetRobucar1103_B.Abs3_n = fabs(projetRobucar1103_B.Gain7);

  /* Sum: '<S49>/Sum12' */
  projetRobucar1103_B.Sum12 = 0.0 - projetRobucar1103_B.Abs3_n;

  /* Gain: '<S61>/D' */
  projetRobucar1103_B.D_a = projetRobucar1103_B.Sum12 *
    projetRobucar1103_P.D_Gain_h;

  /* Derivative Block: '<S61>/Derivative' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_j.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_j.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative_hc = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_j.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative_hc = (projetRobucar1103_B.D_a -
        *lastBank++) / deltaT;
    }
  }

  /* TransferFcn Block: '<S61>/Integral' */
  projetRobucar1103_B.Integral_a =
    projetRobucar1103_P.Integral_C_g*projetRobucar1103_X.Integral_b_CSTATE;

  /* Gain: '<S61>/Proportional' */
  projetRobucar1103_B.Proportional_g = projetRobucar1103_B.Sum12 *
    projetRobucar1103_P.Proportional_Gain_p;

  /* Sum: '<S61>/Sum' */
  projetRobucar1103_B.Sum_aq = (projetRobucar1103_B.Proportional_g +
    projetRobucar1103_B.Integral_a) + projetRobucar1103_B.Derivative_hc;

  /* Gain: '<S49>/Gain6' */
  projetRobucar1103_B.Gain6_i = projetRobucar1103_B.consigne *
    projetRobucar1103_P.Gain6_Gain_m;

  /* Gain: '<S49>/Gain2' */
  projetRobucar1103_B.Gain2_m = projetRobucar1103_B.consigne *
    projetRobucar1103_P.Gain2_Gain_f;

  /* Gain: '<S49>/Gain14' */
  projetRobucar1103_B.Gain14 = projetRobucar1103_B.consigne *
    projetRobucar1103_P.Gain14_Gain;

  /* Gain: '<S49>/Gain10' */
  projetRobucar1103_B.Gain10 = projetRobucar1103_B.consigne *
    projetRobucar1103_P.Gain10_Gain;

  {
    real_T rtsaturate_U0DataInY0Container;

    /* Switch: '<S49>/Switch' incorporates:
     *  Constant: '<S49>/Constant1'
     */
    if(projetRobucar1103_B.marche_arriere >
     projetRobucar1103_P.Switch_Threshold_p) {

      /* Gain: '<S49>/Gain3' */
      projetRobucar1103_B.Gain3_h = projetRobucar1103_B.Gain2_m *
        projetRobucar1103_P.Gain3_Gain_h;

      /* Sum: '<S49>/Sum' */
      projetRobucar1103_B.Sum_d = projetRobucar1103_P.Constant1_Value_b -
        projetRobucar1103_B.Gain3_h;
      projetRobucar1103_B.Switch_kz = projetRobucar1103_B.Sum_d;
    } else {

      /* Gain: '<S49>/Gain4' */
      projetRobucar1103_B.Gain4_kn = projetRobucar1103_B.Gain2_m *
        projetRobucar1103_P.Gain4_Gain_m;

      /* Sum: '<S49>/Sum1' */
      projetRobucar1103_B.Sum1_i = projetRobucar1103_P.Constant1_Value_b +
        projetRobucar1103_B.Gain4_kn;
      projetRobucar1103_B.Switch_kz = projetRobucar1103_B.Sum1_i;
    }

    /* Gain: '<S49>/Gain1' */
    projetRobucar1103_B.Gain1_l = projetRobucar1103_B.Switch_kz *
      projetRobucar1103_P.Gain1_Gain_i;

    /* Saturate: '<S49>/Saturation M_ArG' */
    rtsaturate_U0DataInY0Container = rt_SATURATE(projetRobucar1103_B.Gain1_l,
     projetRobucar1103_P.SaturationM_ArG_LowerSat,
     projetRobucar1103_P.SaturationM_ArG_UpperSat);
    projetRobucar1103_B.SaturationM_ArG = rtsaturate_U0DataInY0Container;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* dSPACE I/O Board DS1103 #1 Unit:DAC */
    ds1103_dac_write(5, projetRobucar1103_B.SaturationM_ArG);
  }

  /* Switch: '<S49>/Switch1' incorporates:
   *  Constant: '<S49>/Constant2'
   */
  if(projetRobucar1103_B.marche_arriere >
   projetRobucar1103_P.Switch1_Threshold_o) {

    /* Gain: '<S49>/Gain7' */
    projetRobucar1103_B.Gain7_j = projetRobucar1103_B.Gain6_i *
      projetRobucar1103_P.Gain7_Gain_f;

    /* Sum: '<S49>/Sum3' */
    projetRobucar1103_B.Sum3_j = projetRobucar1103_P.Constant2_Value -
      projetRobucar1103_B.Gain7_j;
    projetRobucar1103_B.Switch1_a = projetRobucar1103_B.Sum3_j;
  } else {

    /* Gain: '<S49>/Gain8' */
    projetRobucar1103_B.Gain8 = projetRobucar1103_B.Gain6_i *
      projetRobucar1103_P.Gain8_Gain;

    /* Sum: '<S49>/Sum4' */
    projetRobucar1103_B.Sum4 = projetRobucar1103_P.Constant2_Value +
      projetRobucar1103_B.Gain8;
    projetRobucar1103_B.Switch1_a = projetRobucar1103_B.Sum4;
  }

  /* Gain: '<S49>/Gain5' */
  projetRobucar1103_B.Gain5_h = projetRobucar1103_B.Switch1_a *
    projetRobucar1103_P.Gain5_Gain_c;

  {
    real_T rtsaturate_U0DataInY0Container;

    /* Sum: '<S49>/Sum6' incorporates:
     *  Constant: '<S49>/coef_inv'
     */
    projetRobucar1103_B.Sum6 = projetRobucar1103_P.coef_inv_Value -
      projetRobucar1103_B.Gain5_h;

    /* Saturate: '<S49>/Saturation M_ArD' */
    rtsaturate_U0DataInY0Container = rt_SATURATE(projetRobucar1103_B.Sum6,
     projetRobucar1103_P.SaturationM_ArD_LowerSat,
     projetRobucar1103_P.SaturationM_ArD_UpperSat);
    projetRobucar1103_B.SaturationM_ArD = rtsaturate_U0DataInY0Container;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* dSPACE I/O Board DS1103 #1 Unit:DAC */
    ds1103_dac_write(6, projetRobucar1103_B.SaturationM_ArD);
  }

  {
    real_T rtsaturate_U0DataInY0Container;

    /* Switch: '<S49>/Switch2' incorporates:
     *  Constant: '<S49>/Constant3'
     */
    if(projetRobucar1103_B.marche_arriere >
     projetRobucar1103_P.Switch2_Threshold_j) {

      /* Gain: '<S49>/Gain11' */
      projetRobucar1103_B.Gain11 = projetRobucar1103_B.Gain10 *
        projetRobucar1103_P.Gain11_Gain;

      /* Sum: '<S49>/Sum7' */
      projetRobucar1103_B.Sum7 = projetRobucar1103_P.Constant3_Value -
        projetRobucar1103_B.Gain11;
      projetRobucar1103_B.Switch2_a = projetRobucar1103_B.Sum7;
    } else {

      /* Gain: '<S49>/Gain12' */
      projetRobucar1103_B.Gain12 = projetRobucar1103_B.Gain10 *
        projetRobucar1103_P.Gain12_Gain;

      /* Sum: '<S49>/Sum8' */
      projetRobucar1103_B.Sum8 = projetRobucar1103_P.Constant3_Value +
        projetRobucar1103_B.Gain12;
      projetRobucar1103_B.Switch2_a = projetRobucar1103_B.Sum8;
    }

    /* Gain: '<S49>/Gain9' */
    projetRobucar1103_B.Gain9 = projetRobucar1103_B.Switch2_a *
      projetRobucar1103_P.Gain9_Gain;

    /* Saturate: '<S49>/Saturation M_ArG1' */
    rtsaturate_U0DataInY0Container = rt_SATURATE(projetRobucar1103_B.Gain9,
     projetRobucar1103_P.SaturationM_ArG1_LowerSat,
     projetRobucar1103_P.SaturationM_ArG1_UpperSat);
    projetRobucar1103_B.SaturationM_ArG1 = rtsaturate_U0DataInY0Container;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* dSPACE I/O Board DS1103 #1 Unit:DAC */
    ds1103_dac_write(1, projetRobucar1103_B.SaturationM_ArG1);
  }

  /* Switch: '<S49>/Switch3' incorporates:
   *  Constant: '<S49>/Constant4'
   */
  if(projetRobucar1103_B.marche_arriere >
   projetRobucar1103_P.Switch3_Threshold_e) {

    /* Gain: '<S49>/Gain15' */
    projetRobucar1103_B.Gain15 = projetRobucar1103_B.Gain14 *
      projetRobucar1103_P.Gain15_Gain;

    /* Sum: '<S49>/Sum10' */
    projetRobucar1103_B.Sum10 = projetRobucar1103_P.Constant4_Value -
      projetRobucar1103_B.Gain15;
    projetRobucar1103_B.Switch3_c = projetRobucar1103_B.Sum10;
  } else {

    /* Gain: '<S49>/Gain16' */
    projetRobucar1103_B.Gain16 = projetRobucar1103_B.Gain14 *
      projetRobucar1103_P.Gain16_Gain;

    /* Sum: '<S49>/Sum11' */
    projetRobucar1103_B.Sum11 = projetRobucar1103_P.Constant4_Value +
      projetRobucar1103_B.Gain16;
    projetRobucar1103_B.Switch3_c = projetRobucar1103_B.Sum11;
  }

  /* Gain: '<S49>/Gain13' */
  projetRobucar1103_B.Gain13 = projetRobucar1103_B.Switch3_c *
    projetRobucar1103_P.Gain13_Gain;

  {
    real_T rtsaturate_U0DataInY0Container;

    /* Sum: '<S49>/Sum13' incorporates:
     *  Constant: '<S49>/coef_inv1'
     */
    projetRobucar1103_B.Sum13 = projetRobucar1103_P.coef_inv1_Value -
      projetRobucar1103_B.Gain13;

    /* Saturate: '<S49>/Saturation M_ArD1' */
    rtsaturate_U0DataInY0Container = rt_SATURATE(projetRobucar1103_B.Sum13,
     projetRobucar1103_P.SaturationM_ArD1_LowerSat,
     projetRobucar1103_P.SaturationM_ArD1_UpperSat);
    projetRobucar1103_B.SaturationM_ArD1 = rtsaturate_U0DataInY0Container;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* dSPACE I/O Board DS1103 #1 Unit:DAC */
    ds1103_dac_write(2, projetRobucar1103_B.SaturationM_ArD1);
  }

  /* Gain: '<S28>/Gain2' */
  projetRobucar1103_B.Gain2_d = projetRobucar1103_B.Abs1 *
    projetRobucar1103_P.Gain2_Gain_c;

  /* Gain: '<S28>/Gain1' */
  projetRobucar1103_B.Gain1_p = projetRobucar1103_B.Abs *
    projetRobucar1103_P.Gain1_Gain_c;

  /* Gain: '<S28>/Gain4' */
  projetRobucar1103_B.Gain4_k = projetRobucar1103_B.Abs3 *
    projetRobucar1103_P.Gain4_Gain_e;

  /* Gain: '<S28>/Gain3' */
  projetRobucar1103_B.Gain3_i = projetRobucar1103_B.Abs2 *
    projetRobucar1103_P.Gain3_Gain_d;

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* dSPACE RTICAN RX Message Block: "RX Message" Id:0 */
    {
      UInt32 *CAN_Msg;
      /* ... Read status and timestamp info (previous message) */
      ds1103_can_msg_read_from_mem(ds1103_msg_B1[DS1103_B1_C1_RX_STD_0X0]);
      if (ds1103_msg_B1[DS1103_B1_C1_RX_STD_0X0]->processed){
        projetRobucar1103_B.SFunction1_o5 =
          (real_T)ds1103_msg_B1[DS1103_B1_C1_RX_STD_0X0]->processed;
        projetRobucar1103_B.SFunction1_o6 =
          (real_T)ds1103_msg_B1[DS1103_B1_C1_RX_STD_0X0]->timestamp;
        projetRobucar1103_B.SFunction1_o7 =
          (real_T)ds1103_msg_B1[DS1103_B1_C1_RX_STD_0X0]->deltatime;

        CAN_Msg = ds1103_msg_B1[DS1103_B1_C1_RX_STD_0X0]->data;
        /* ... Decode CAN Message */

        {
          rtican_Signal_t CAN_Sgn;
          /* ...... "position_Av_p1" (0|8, standard signal, unsigned int, little endian) */
          CAN_Sgn.SgnBytes.Byte0 = CAN_Msg[0];
          CAN_Sgn.UnsignedSgn &= 0x000000FF;
          projetRobucar1103_B.SFunction1_o1 = ((real_T) CAN_Sgn.UnsignedSgn);

          /* ...... "position_Av_p2" (8|8, standard signal, unsigned int, little endian) */
          CAN_Sgn.SgnBytes.Byte0 = CAN_Msg[1];
          CAN_Sgn.UnsignedSgn &= 0x000000FF;
          projetRobucar1103_B.SFunction1_o2 = ((real_T) CAN_Sgn.UnsignedSgn);

          /* ...... "position_Ar_p1" (16|8, standard signal, unsigned int, little endian) */
          CAN_Sgn.SgnBytes.Byte0 = CAN_Msg[2];
          CAN_Sgn.UnsignedSgn &= 0x000000FF;
          projetRobucar1103_B.SFunction1_o3 = ((real_T) CAN_Sgn.UnsignedSgn);

          /* ...... "position_Ar_p2" (24|8, standard signal, unsigned int, little endian) */
          CAN_Sgn.SgnBytes.Byte0 = CAN_Msg[3];
          CAN_Sgn.UnsignedSgn &= 0x000000FF;
          projetRobucar1103_B.SFunction1_o4 = ((real_T) CAN_Sgn.UnsignedSgn);
        }
      }
      else{
        /* ... set RX status to 0 because no new message has arrived */
        projetRobucar1103_B.SFunction1_o5 = 0.0;
      }
    }

    /* This comment workarounds a Real-Time Workshop code generation problem */
  }

  /* Integrator Block: '<S15>/Integrator'
   */
  projetRobucar1103_B.Ie = projetRobucar1103_X.Integrator_CSTATE;

  /* TransferFcn Block: '<S5>/filtre1' */
  projetRobucar1103_B.filtre1 =
    projetRobucar1103_P.filtre1_C*projetRobucar1103_X.filtre1_CSTATE;

  /* TransferFcn Block: '<S5>/filtre' */
  projetRobucar1103_B.filtre =
    projetRobucar1103_P.filtre_C*projetRobucar1103_X.filtre_CSTATE;

  /* Embedded MATLAB Block: '<S5>/Detection et isolation'
   */

  {
    int32_T eml_y;
    /*  This block supports an embeddable subset of the MATLAB language. */
    /*  See the help menu for details.  */
    eml_y = -1;
    if((fabs(projetRobucar1103_B.filtre1) > projetRobucar1103_P.U1_Value) &&
     (fabs(projetRobucar1103_B.filtre) < projetRobucar1103_P.U4_Value)) {
      eml_y = 1;
    }
    if((fabs(projetRobucar1103_B.filtre1) > projetRobucar1103_P.U1_Value) &&
     (fabs(projetRobucar1103_B.filtre) > projetRobucar1103_P.U4_Value)) {
      eml_y = 3;
    }
    if((fabs(projetRobucar1103_B.filtre1) < projetRobucar1103_P.U1_Value) &&
     (fabs(projetRobucar1103_B.filtre) > projetRobucar1103_P.U4_Value)) {
      eml_y = 5;
    }
    projetRobucar1103_B.y_e = (real_T)eml_y;
  }

  /* Integrator Block: '<S15>/Integrator1'
   */
  projetRobucar1103_B.vitessemoteur = projetRobucar1103_X.Integrator1_CSTATE;

  /* Gain: '<S15>/rducteur' */
  projetRobucar1103_B.rducteur = projetRobucar1103_B.vitessemoteur *
    projetRobucar1103_P.rducteur_Gain;

  /* Switch: '<S12>/Switch1' incorporates:
   *  Constant: '<S12>/Cmd defaut vitesse'
   *  Constant: '<S12>/Defaut1'
   */
  if(projetRobucar1103_P.Cmddefautvitesse_Value >
   projetRobucar1103_P.Switch1_Threshold_n) {
    projetRobucar1103_B.Switch1_ap = projetRobucar1103_B.vitessemoteur;
  } else {

    /* Sum: '<S12>/Add2' */
    projetRobucar1103_B.Add2_k = projetRobucar1103_B.vitessemoteur -
      projetRobucar1103_P.Defaut1_Value;
    projetRobucar1103_B.Switch1_ap = projetRobucar1103_B.Add2_k;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[2] == 0) { /* Sample time: [0.1s, 0.0s] */

    /* RandomNumber Block: '<S17>/White Noise'
     */
    projetRobucar1103_B.WhiteNoise =
      projetRobucar1103_DWork.WhiteNoise_RWORK.NextOutput;
  }

  if(rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[2] == 0) {

    /* Gain: '<S17>/Output' */
    projetRobucar1103_B.Output = projetRobucar1103_B.WhiteNoise *
      projetRobucar1103_P.Output_Gain;
  }

  /* Sum: '<S12>/Add3' */
  projetRobucar1103_B.Add3 = projetRobucar1103_B.Switch1_ap +
    projetRobucar1103_B.Output;

  /* Switch: '<S12>/Switch' incorporates:
   *  Constant: '<S12>/Cmd defaut courant'
   *  Constant: '<S12>/Defaut'
   */
  if(projetRobucar1103_P.Cmddefautcourant_Value >
   projetRobucar1103_P.Switch_Threshold_i) {
    projetRobucar1103_B.Switch_h = projetRobucar1103_B.Ie;
  } else {

    /* Sum: '<S12>/Add' */
    projetRobucar1103_B.Add_l = projetRobucar1103_B.Ie -
      projetRobucar1103_P.Defaut_Value;
    projetRobucar1103_B.Switch_h = projetRobucar1103_B.Add_l;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[2] == 0) { /* Sample time: [0.1s, 0.0s] */

    /* RandomNumber Block: '<S16>/White Noise'
     */
    projetRobucar1103_B.WhiteNoise_o =
      projetRobucar1103_DWork.WhiteNoise_RWORK_f.NextOutput;
  }

  if(rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[2] == 0) {

    /* Gain: '<S16>/Output' */
    projetRobucar1103_B.Output_n = projetRobucar1103_B.WhiteNoise_o *
      projetRobucar1103_P.Output_Gain_f;
  }

  /* Sum: '<S12>/Add1' */
  projetRobucar1103_B.Add1 = projetRobucar1103_B.Switch_h +
    projetRobucar1103_B.Output_n;

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */

    /* Sum: '<S19>/Add2' incorporates:
     *  Constant: '<S19>/U1'
     *  Constant: '<S5>/U'
     */
    projetRobucar1103_B.Add2 = projetRobucar1103_P.U_Value -
      projetRobucar1103_P.U1_Value_j;

    /* Gain: '<S19>/gain1' */
    projetRobucar1103_B.gain1 = projetRobucar1103_B.Add2 *
      projetRobucar1103_P.gain1_Gain;

    /* Switch: '<S12>/Switch2' incorporates:
     *  Constant: '<S12>/Cmd defaut tension'
     *  Constant: '<S12>/Defaut2'
     */
    if(projetRobucar1103_P.Cmddefauttension_Value >
     projetRobucar1103_P.Switch2_Threshold_n) {
      projetRobucar1103_B.Switch2_c = projetRobucar1103_B.gain1;
    } else {

      /* Sum: '<S12>/Add4' */
      projetRobucar1103_B.Add4 = projetRobucar1103_B.gain1 -
        projetRobucar1103_P.Defaut2_Value;
      projetRobucar1103_B.Switch2_c = projetRobucar1103_B.Add4;
    }
  }
  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[2] == 0) { /* Sample time: [0.1s, 0.0s] */

    /* RandomNumber Block: '<S18>/White Noise'
     */
    projetRobucar1103_B.WhiteNoise_i =
      projetRobucar1103_DWork.WhiteNoise_RWORK_h.NextOutput;
  }

  if(rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[2] == 0) {

    /* Gain: '<S18>/Output' */
    projetRobucar1103_B.Output_i = projetRobucar1103_B.WhiteNoise_i *
      projetRobucar1103_P.Output_Gain_fl;
  }
  if(rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) {

    /* Sum: '<S12>/Add5' */
    projetRobucar1103_B.Add5 = projetRobucar1103_B.Switch2_c +
      projetRobucar1103_B.Output_i;
  }

  /* Gain: '<S14>/ke2' */
  projetRobucar1103_B.ke2 = projetRobucar1103_B.Add3 *
    projetRobucar1103_P.ke2_Gain;

  /* Derivative Block: '<S14>/Derivative' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_p.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_p.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative_o = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_p.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative_o = (projetRobucar1103_B.Add1 -
        *lastBank++) / deltaT;
    }
  }

  /* Gain: '<S14>/Le' */
  projetRobucar1103_B.Le = projetRobucar1103_B.Derivative_o *
    projetRobucar1103_P.Le_Gain;

  /* Gain: '<S14>/Re' */
  projetRobucar1103_B.Re = projetRobucar1103_B.Add1 *
    projetRobucar1103_P.Re_Gain;

  /* Sum: '<S14>/Add' */
  projetRobucar1103_B.Add_d = ((projetRobucar1103_B.Add5 -
    projetRobucar1103_B.ke2) - projetRobucar1103_B.Le) - projetRobucar1103_B.Re;

  /* Derivative Block: '<S14>/Derivative1' */
  {
    real_T t = projetRobucar1103_M->Timing.t[0];
    real_T timeStampA = projetRobucar1103_DWork.Derivative1_RWORK_b.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative1_RWORK_b.TimeStampB;

    if (timeStampA >= t && timeStampB >= t) {
      projetRobucar1103_B.Derivative1_f = 0.0;
    } else {
      real_T deltaT;
      real_T *lastBank = &projetRobucar1103_DWork.Derivative1_RWORK_b.TimeStampA;
      if (timeStampA < timeStampB) {
        if (timeStampB < t) {
          lastBank += 2;
        }
      } else if (timeStampA >= t) {
        lastBank += 2;
      }
      deltaT = t - *lastBank++;
      projetRobucar1103_B.Derivative1_f = (projetRobucar1103_B.Add3 -
        *lastBank++) / deltaT;
    }
  }

  /* Gain: '<S14>/Je + (Js//N^2)' */
  projetRobucar1103_B.JeJsN2 = projetRobucar1103_B.Derivative1_f *
    projetRobucar1103_P.JeJsN2_Gain;

  /* Gain: '<S14>/Fe + (Fs//N^2)' */
  projetRobucar1103_B.FeFsN2 = projetRobucar1103_B.Add3 *
    projetRobucar1103_P.FeFsN2_Gain;

  /* Gain: '<S14>/ke3' */
  projetRobucar1103_B.ke3 = projetRobucar1103_B.Add1 *
    projetRobucar1103_P.ke3_Gain;

  /* Sum: '<S14>/Add3' */
  projetRobucar1103_B.Add3_o = (projetRobucar1103_B.ke3 -
    projetRobucar1103_B.JeJsN2) - projetRobucar1103_B.FeFsN2;

  /* Gain: '<S15>/Ke' */
  projetRobucar1103_B.Ke = projetRobucar1103_B.vitessemoteur *
    projetRobucar1103_P.Ke_Gain;

  /* Gain: '<S15>/Re' */
  projetRobucar1103_B.Re_n = projetRobucar1103_B.Ie *
    projetRobucar1103_P.Re_Gain_b;

  /* Sum: '<S15>/Add' */
  projetRobucar1103_B.Add_e = (projetRobucar1103_B.gain1 -
    projetRobucar1103_B.Ke) - projetRobucar1103_B.Re_n;

  /* Gain: '<S15>/1//Le' */
  projetRobucar1103_B.Le_b = projetRobucar1103_B.Add_e *
    projetRobucar1103_P.Le_Gain_d;

  /* Gain: '<S15>/ke1' */
  projetRobucar1103_B.ke1 = projetRobucar1103_B.Ie *
    projetRobucar1103_P.ke1_Gain;

  /* Gain: '<S15>/Fe + (Fs//N^2)' */
  projetRobucar1103_B.FeFsN2_g = projetRobucar1103_B.vitessemoteur *
    projetRobucar1103_P.FeFsN2_Gain_m;

  /* Sum: '<S15>/Add1' incorporates:
   *  Constant: '<S5>/couple_resistant'
   */
  projetRobucar1103_B.Add1_b = (projetRobucar1103_B.ke1 -
    projetRobucar1103_P.couple_resistant_Value) - projetRobucar1103_B.FeFsN2_g;

  /* Gain: '<S15>/1//[Je + (Js//N^2)]' */
  projetRobucar1103_B.JeJsN2_p = projetRobucar1103_B.Add1_b *
    projetRobucar1103_P.JeJsN2_Gain_m;

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) { /* Sample time: [0.001s, 0.0s] */
    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* Gain: '<S6>/Gain1' */
    projetRobucar1103_B.Gain1_j = projetRobucar1103_B.SFunction *
      projetRobucar1103_P.Gain1_Gain_f;

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* Gain: '<S6>/Gain2' */
    projetRobucar1103_B.Gain2_a = projetRobucar1103_B.SFunction_o *
      projetRobucar1103_P.Gain2_Gain_a;

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* Gain: '<S6>/Gain3' */
    projetRobucar1103_B.Gain3_a = projetRobucar1103_B.SFunction_i *
      projetRobucar1103_P.Gain3_Gain_b;

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* Gain: '<S6>/Gain4' */
    projetRobucar1103_B.Gain4_kr = projetRobucar1103_B.SFunction_a *
      projetRobucar1103_P.Gain4_Gain_d;

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* Gain: '<S7>/Gain' */
    projetRobucar1103_B.Gain_c = projetRobucar1103_B.SFunction_d[0] *
      projetRobucar1103_P.Gain_Gain_k;

    /* Gain: '<S7>/Gain5' */
    projetRobucar1103_B.Gain5_o = projetRobucar1103_B.SFunction_d[1] *
      projetRobucar1103_P.Gain5_Gain_k;

    /* Sum: '<S7>/Sum' */
    projetRobucar1103_B.Sum_fx = projetRobucar1103_B.Gain_c -
      projetRobucar1103_B.Gain5_o;

    /* Gain: '<S7>/Gain6' */
    projetRobucar1103_B.Gain6_g = projetRobucar1103_B.SFunction_d[2] *
      projetRobucar1103_P.Gain6_Gain_k;

    /* Gain: '<S7>/Gain7' */
    projetRobucar1103_B.Gain7_g = projetRobucar1103_B.SFunction_d[3] *
      projetRobucar1103_P.Gain7_Gain_p;

    /* Sum: '<S7>/Sum1' */
    projetRobucar1103_B.Sum1_h = projetRobucar1103_B.Gain6_g -
      projetRobucar1103_B.Gain7_g;

    /* This comment workarounds a Real-Time Workshop code generation problem */

    /* Gain: '<S7>/Gain1' */
    projetRobucar1103_B.Gain1_a = projetRobucar1103_B.SFunction_j[0] *
      projetRobucar1103_P.Gain1_Gain_l;

    /* Gain: '<S7>/Gain2' */
    projetRobucar1103_B.Gain2_k = projetRobucar1103_B.SFunction_j[1] *
      projetRobucar1103_P.Gain2_Gain_ad;

    /* Sum: '<S7>/Sum2' */
    projetRobucar1103_B.Sum2_br = projetRobucar1103_B.Gain1_a -
      projetRobucar1103_B.Gain2_k;

    /* Gain: '<S7>/Gain3' */
    projetRobucar1103_B.Gain3_c = projetRobucar1103_B.SFunction_j[2] *
      projetRobucar1103_P.Gain3_Gain_a;

    /* Gain: '<S7>/Gain4' */
    projetRobucar1103_B.Gain4_i = projetRobucar1103_B.SFunction_j[3] *
      projetRobucar1103_P.Gain4_Gain_p;

    /* Sum: '<S7>/Sum3' */
    projetRobucar1103_B.Sum3 = projetRobucar1103_B.Gain3_c -
      projetRobucar1103_B.Gain4_i;
  }

  /* user code (Output function Trailer) */
  /* dSPACE Data Capture block: (none) */
  /* ... Service number: 1 */
  /* ... Service name:   (default) */
  if (rtmIsContinuousTask(projetRobucar1103_M, tid) &&
   rtmIsMajorTimeStep(projetRobucar1103_M)) {
    host_service(1, rtk_current_task_absolute_time_ptr_get());
  }
}

/* Model update function */

void projetRobucar1103_update(int_T tid)
{

  /* Derivative Block: '<S48>/Derivative' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.Gain;
  }

  /* Derivative Block: '<S48>/Derivative1' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative1_RWORK.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative1_RWORK.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative1_RWORK.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.Gain1;
  }

  /* Derivative Block: '<S48>/Derivative2' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative2_RWORK.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative2_RWORK.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative2_RWORK.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.Gain4;
  }

  /* Derivative Block: '<S48>/Derivative3' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative3_RWORK.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative3_RWORK.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative3_RWORK.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.Gain5;
  }

  if(rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) {
  }

  /* TransportDelay Block: '<S35>/Transport Delay' */
  {
    real_T **uBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay_PWORK.TUbufferPtrs[0];
    real_T **tBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay_PWORK.TUbufferPtrs[1];

    real_T simTime = projetRobucar1103_M->Timing.t[0];

    projetRobucar1103_DWork.TransportDelay_IWORK.Head =
      ((projetRobucar1103_DWork.TransportDelay_IWORK.Head <
      (projetRobucar1103_DWork.TransportDelay_IWORK.CircularBufSize-1)) ?
      (projetRobucar1103_DWork.TransportDelay_IWORK.Head+1) : 0);

    if (projetRobucar1103_DWork.TransportDelay_IWORK.Head ==
     projetRobucar1103_DWork.TransportDelay_IWORK.Tail) {

      projetRobucar1103_DWork.TransportDelay_IWORK.Tail =
        ((projetRobucar1103_DWork.TransportDelay_IWORK.Tail <
        (projetRobucar1103_DWork.TransportDelay_IWORK.CircularBufSize-1)) ?
        (projetRobucar1103_DWork.TransportDelay_IWORK.Tail+1) : 0);
    }

    (*tBuffer)[projetRobucar1103_DWork.TransportDelay_IWORK.Head] = simTime;
    (*uBuffer)[projetRobucar1103_DWork.TransportDelay_IWORK.Head] =
      projetRobucar1103_B.e_w_i;
  }

  /* TransportDelay Block: '<S35>/Transport Delay1' */
  {
    real_T **uBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay1_PWORK.TUbufferPtrs[0];
    real_T **tBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay1_PWORK.TUbufferPtrs[1];

    real_T simTime = projetRobucar1103_M->Timing.t[0];

    projetRobucar1103_DWork.TransportDelay1_IWORK.Head =
      ((projetRobucar1103_DWork.TransportDelay1_IWORK.Head <
      (projetRobucar1103_DWork.TransportDelay1_IWORK.CircularBufSize-1)) ?
      (projetRobucar1103_DWork.TransportDelay1_IWORK.Head+1) : 0);

    if (projetRobucar1103_DWork.TransportDelay1_IWORK.Head ==
     projetRobucar1103_DWork.TransportDelay1_IWORK.Tail) {

      projetRobucar1103_DWork.TransportDelay1_IWORK.Tail =
        ((projetRobucar1103_DWork.TransportDelay1_IWORK.Tail <
        (projetRobucar1103_DWork.TransportDelay1_IWORK.CircularBufSize-1)) ?
        (projetRobucar1103_DWork.TransportDelay1_IWORK.Tail+1) : 0);
    }

    (*tBuffer)[projetRobucar1103_DWork.TransportDelay1_IWORK.Head] = simTime;
    (*uBuffer)[projetRobucar1103_DWork.TransportDelay1_IWORK.Head] =
      projetRobucar1103_B.DataTypeConversion1;
  }

  /* Derivative Block: '<S37>/Derivative' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_c.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_c.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_c.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.D;
  }

  /* TransportDelay Block: '<S36>/Transport Delay' */
  {
    real_T **uBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay_PWORK_c.TUbufferPtrs[0];
    real_T **tBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay_PWORK_c.TUbufferPtrs[1];

    real_T simTime = projetRobucar1103_M->Timing.t[0];

    projetRobucar1103_DWork.TransportDelay_IWORK_n.Head =
      ((projetRobucar1103_DWork.TransportDelay_IWORK_n.Head <
      (projetRobucar1103_DWork.TransportDelay_IWORK_n.CircularBufSize-1)) ?
      (projetRobucar1103_DWork.TransportDelay_IWORK_n.Head+1) : 0);

    if (projetRobucar1103_DWork.TransportDelay_IWORK_n.Head ==
     projetRobucar1103_DWork.TransportDelay_IWORK_n.Tail) {

      projetRobucar1103_DWork.TransportDelay_IWORK_n.Tail =
        ((projetRobucar1103_DWork.TransportDelay_IWORK_n.Tail <
        (projetRobucar1103_DWork.TransportDelay_IWORK_n.CircularBufSize-1)) ?
        (projetRobucar1103_DWork.TransportDelay_IWORK_n.Tail+1) : 0);
    }

    (*tBuffer)[projetRobucar1103_DWork.TransportDelay_IWORK_n.Head] = simTime;
    (*uBuffer)[projetRobucar1103_DWork.TransportDelay_IWORK_n.Head] =
      projetRobucar1103_B.e_w;
  }

  /* TransportDelay Block: '<S36>/Transport Delay1' */
  {
    real_T **uBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay1_PWORK_a.TUbufferPtrs[0];
    real_T **tBuffer =
      (real_T**)&projetRobucar1103_DWork.TransportDelay1_PWORK_a.TUbufferPtrs[1];

    real_T simTime = projetRobucar1103_M->Timing.t[0];

    projetRobucar1103_DWork.TransportDelay1_IWORK_k.Head =
      ((projetRobucar1103_DWork.TransportDelay1_IWORK_k.Head <
      (projetRobucar1103_DWork.TransportDelay1_IWORK_k.CircularBufSize-1)) ?
      (projetRobucar1103_DWork.TransportDelay1_IWORK_k.Head+1) : 0);

    if (projetRobucar1103_DWork.TransportDelay1_IWORK_k.Head ==
     projetRobucar1103_DWork.TransportDelay1_IWORK_k.Tail) {

      projetRobucar1103_DWork.TransportDelay1_IWORK_k.Tail =
        ((projetRobucar1103_DWork.TransportDelay1_IWORK_k.Tail <
        (projetRobucar1103_DWork.TransportDelay1_IWORK_k.CircularBufSize-1)) ?
        (projetRobucar1103_DWork.TransportDelay1_IWORK_k.Tail+1) : 0);
    }

    (*tBuffer)[projetRobucar1103_DWork.TransportDelay1_IWORK_k.Head] = simTime;
    (*uBuffer)[projetRobucar1103_DWork.TransportDelay1_IWORK_k.Head] =
      projetRobucar1103_B.DataTypeConversion1_m;
  }

  /* Derivative Block: '<S38>/Derivative' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_i.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_i.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_i.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.D_j;
  }

  /* Derivative Block: '<S62>/Derivative' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_g.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_g.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_g.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.D_g;
  }

  /* Derivative Block: '<S59>/Derivative' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_f.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_f.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_f.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.D_c;
  }

  /* Derivative Block: '<S60>/Derivative' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_d.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_d.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_d.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.D_f;
  }

  /* Derivative Block: '<S61>/Derivative' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_j.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_j.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_j.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.D_a;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[2] == 0) { /* Sample time: [0.1s, 0.0s] */

    /* RandomNumber Block: '<S17>/White Noise' */
    projetRobucar1103_DWork.WhiteNoise_RWORK.NextOutput =
      rt_NormalRand((uint32_T
      *)&projetRobucar1103_DWork.WhiteNoise_IWORK.RandSeed)*projetRobucar1103_P.WhiteNoise_StdDev+projetRobucar1103_P.WhiteNoise_Mean;

    /* RandomNumber Block: '<S16>/White Noise' */
    projetRobucar1103_DWork.WhiteNoise_RWORK_f.NextOutput =
      rt_NormalRand((uint32_T
      *)&projetRobucar1103_DWork.WhiteNoise_IWORK_g.RandSeed)*projetRobucar1103_P.WhiteNoise_StdDev_p+projetRobucar1103_P.WhiteNoise_Mean_d;

    /* RandomNumber Block: '<S18>/White Noise' */
    projetRobucar1103_DWork.WhiteNoise_RWORK_h.NextOutput =
      rt_NormalRand((uint32_T
      *)&projetRobucar1103_DWork.WhiteNoise_IWORK_f.RandSeed)*projetRobucar1103_P.WhiteNoise_StdDev_p5+projetRobucar1103_P.WhiteNoise_Mean_m;
  }

  /* Derivative Block: '<S14>/Derivative' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative_RWORK_p.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative_RWORK_p.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative_RWORK_p.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.Add1;
  }

  /* Derivative Block: '<S14>/Derivative1' */
  {
    real_T timeStampA = projetRobucar1103_DWork.Derivative1_RWORK_b.TimeStampA;
    real_T timeStampB = projetRobucar1103_DWork.Derivative1_RWORK_b.TimeStampB;
    real_T *lastBank = &projetRobucar1103_DWork.Derivative1_RWORK_b.TimeStampA;

    if (timeStampA != rtInf) {
      if (timeStampB == rtInf) {
        lastBank += 2;
      } else if (timeStampA >= timeStampB) {
        lastBank += 2;
      }
    }
    *lastBank++ = projetRobucar1103_M->Timing.t[0];
    *lastBank++ = projetRobucar1103_B.Add3;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M)) {
    rt_ertODEUpdateContinuousStates(&projetRobucar1103_M->solverInfo);
  }

  /* Update absolute time for base rate */
  if(!(++projetRobucar1103_M->Timing.clockTick0))
  ++projetRobucar1103_M->Timing.clockTickH0;
  projetRobucar1103_M->Timing.t[0] = projetRobucar1103_M->Timing.clockTick0 *
    projetRobucar1103_M->Timing.stepSize0 +
    projetRobucar1103_M->Timing.clockTickH0 *
    projetRobucar1103_M->Timing.stepSize0 * 4294967296.0;

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[1] == 0) {
    /* Update absolute timer for sample time: [0.001s, 0.0s] */
    if(!(++projetRobucar1103_M->Timing.clockTick1))
    ++projetRobucar1103_M->Timing.clockTickH1;
    projetRobucar1103_M->Timing.t[1] = projetRobucar1103_M->Timing.clockTick1 *
      projetRobucar1103_M->Timing.stepSize1 +
      projetRobucar1103_M->Timing.clockTickH1 *
      projetRobucar1103_M->Timing.stepSize1 * 4294967296.0;
  }

  if (rtmIsMajorTimeStep(projetRobucar1103_M) &&
   projetRobucar1103_M->Timing.TaskCounters.TID[2] == 0) {
    /* Update absolute timer for sample time: [0.1s, 0.0s] */
    if(!(++projetRobucar1103_M->Timing.clockTick2))
    ++projetRobucar1103_M->Timing.clockTickH2;
    projetRobucar1103_M->Timing.t[2] = projetRobucar1103_M->Timing.clockTick2 *
      projetRobucar1103_M->Timing.stepSize2 +
      projetRobucar1103_M->Timing.clockTickH2 *
      projetRobucar1103_M->Timing.stepSize2 * 4294967296.0;
  }

  rate_scheduler();
}

/* Derivatives for root system: '<Root>' */

void projetRobucar1103_derivatives(void)
{

  /* simstruct variables */
  StateDerivatives_projetRobucar1 *projetRobucar1103_Xdot =
    (StateDerivatives_projetRobucar1*) projetRobucar1103_M->ModelData.derivs;

  /* TransferFcn Block: '<S37>/Integral' */
  {

    projetRobucar1103_Xdot->Integral_CSTATE = projetRobucar1103_B.e_pid_g;
    projetRobucar1103_Xdot->Integral_CSTATE +=
      (projetRobucar1103_P.Integral_A)*projetRobucar1103_X.Integral_CSTATE;
  }

  /* TransferFcn Block: '<S38>/Integral' */
  {

    projetRobucar1103_Xdot->Integral_j_CSTATE = projetRobucar1103_B.e_pid;
    projetRobucar1103_Xdot->Integral_j_CSTATE +=
      (projetRobucar1103_P.Integral_A_i)*projetRobucar1103_X.Integral_j_CSTATE;
  }

  /* TransferFcn Block: '<S62>/Integral' */
  {

    projetRobucar1103_Xdot->Integral_h_CSTATE = projetRobucar1103_B.Sum9;
    projetRobucar1103_Xdot->Integral_h_CSTATE +=
      (projetRobucar1103_P.Integral_A_j)*projetRobucar1103_X.Integral_h_CSTATE;
  }

  /* TransferFcn Block: '<S59>/Integral' */
  {

    projetRobucar1103_Xdot->Integral_e_CSTATE = projetRobucar1103_B.Sum5;
    projetRobucar1103_Xdot->Integral_e_CSTATE +=
      (projetRobucar1103_P.Integral_A_d)*projetRobucar1103_X.Integral_e_CSTATE;
  }

  /* TransferFcn Block: '<S60>/Integral' */
  {

    projetRobucar1103_Xdot->Integral_c_CSTATE = projetRobucar1103_B.Sum2_b;
    projetRobucar1103_Xdot->Integral_c_CSTATE +=
      (projetRobucar1103_P.Integral_A_jc)*projetRobucar1103_X.Integral_c_CSTATE;
  }

  /* TransferFcn Block: '<S61>/Integral' */
  {

    projetRobucar1103_Xdot->Integral_b_CSTATE = projetRobucar1103_B.Sum12;
    projetRobucar1103_Xdot->Integral_b_CSTATE +=
      (projetRobucar1103_P.Integral_A_o)*projetRobucar1103_X.Integral_b_CSTATE;
  }

  /* Integrator Block: <S15>/Integrator */
  {

    projetRobucar1103_Xdot->Integrator_CSTATE = projetRobucar1103_B.Le_b;
  }

  /* TransferFcn Block: '<S5>/filtre1' */
  {

    projetRobucar1103_Xdot->filtre1_CSTATE = projetRobucar1103_B.Add_d;
    projetRobucar1103_Xdot->filtre1_CSTATE +=
      (projetRobucar1103_P.filtre1_A)*projetRobucar1103_X.filtre1_CSTATE;
  }

  /* TransferFcn Block: '<S5>/filtre' */
  {

    projetRobucar1103_Xdot->filtre_CSTATE = projetRobucar1103_B.Add3_o;
    projetRobucar1103_Xdot->filtre_CSTATE +=
      (projetRobucar1103_P.filtre_A)*projetRobucar1103_X.filtre_CSTATE;
  }

  /* Integrator Block: <S15>/Integrator1 */
  {

    projetRobucar1103_Xdot->Integrator1_CSTATE = projetRobucar1103_B.JeJsN2_p;
  }
}

/* Model initialize function */

void projetRobucar1103_initialize(boolean_T firstTime)
{
  if (firstTime) {

    /* Registration code */
    /* initialize real-time model */
    (void) memset((char_T *)projetRobucar1103_M,0,
     sizeof(RT_MODEL_projetRobucar1103));

    {
      /* Setup solver object */

      rtsiSetSimTimeStepPtr(&projetRobucar1103_M->solverInfo,
       &projetRobucar1103_M->Timing.simTimeStep);
      rtsiSetTPtr(&projetRobucar1103_M->solverInfo,
       &rtmGetTPtr(projetRobucar1103_M));
      rtsiSetStepSizePtr(&projetRobucar1103_M->solverInfo,
       &projetRobucar1103_M->Timing.stepSize0);
      rtsiSetdXPtr(&projetRobucar1103_M->solverInfo,
       &projetRobucar1103_M->ModelData.derivs);
      rtsiSetContStatesPtr(&projetRobucar1103_M->solverInfo,
       &projetRobucar1103_M->ModelData.contStates);
      rtsiSetNumContStatesPtr(&projetRobucar1103_M->solverInfo,
       &projetRobucar1103_M->Sizes.numContStates);
      rtsiSetErrorStatusPtr(&projetRobucar1103_M->solverInfo,
       &rtmGetErrorStatus(projetRobucar1103_M));

      rtsiSetRTModelPtr(&projetRobucar1103_M->solverInfo, projetRobucar1103_M);
    }
    rtsiSetSimTimeStep(&projetRobucar1103_M->solverInfo, MAJOR_TIME_STEP);
    projetRobucar1103_M->ModelData.intgData.f[0] =
      projetRobucar1103_M->ModelData.odeF[0];
    projetRobucar1103_M->ModelData.contStates = ((real_T *)
      &projetRobucar1103_X);
    rtsiSetSolverData(&projetRobucar1103_M->solverInfo, (void
      *)&projetRobucar1103_M->ModelData.intgData);
    rtsiSetSolverName(&projetRobucar1103_M->solverInfo,"ode1");

    /* Initialize timing info */
    {
      int_T *mdlTsMap = projetRobucar1103_M->Timing.sampleTimeTaskIDArray;
      mdlTsMap[0] = 0;
      mdlTsMap[1] = 1;
      mdlTsMap[2] = 2;
      projetRobucar1103_M->Timing.sampleTimeTaskIDPtr = (&mdlTsMap[0]);
      projetRobucar1103_M->Timing.sampleTimes =
        (&projetRobucar1103_M->Timing.sampleTimesArray[0]);
      projetRobucar1103_M->Timing.offsetTimes =
        (&projetRobucar1103_M->Timing.offsetTimesArray[0]);
      /* task periods */
      projetRobucar1103_M->Timing.sampleTimes[0] = (0.0);
      projetRobucar1103_M->Timing.sampleTimes[1] = (0.001);
      projetRobucar1103_M->Timing.sampleTimes[2] = (0.1);

      /* task offsets */
      projetRobucar1103_M->Timing.offsetTimes[0] = (0.0);
      projetRobucar1103_M->Timing.offsetTimes[1] = (0.0);
      projetRobucar1103_M->Timing.offsetTimes[2] = (0.0);
    }

    rtmSetTPtr(projetRobucar1103_M, &projetRobucar1103_M->Timing.tArray[0]);

    {
      int_T *mdlSampleHits = projetRobucar1103_M->Timing.sampleHitArray;
      mdlSampleHits[0] = 1;
      mdlSampleHits[1] = 1;
      mdlSampleHits[2] = 1;
      projetRobucar1103_M->Timing.sampleHits = (&mdlSampleHits[0]);
    }

    rtmSetTFinal(projetRobucar1103_M, -1);
    projetRobucar1103_M->Timing.stepSize0 = 0.001;
    projetRobucar1103_M->Timing.stepSize1 = 0.001;
    projetRobucar1103_M->Timing.stepSize2 = 0.1;

    /* Setup for data logging */
    {
      static RTWLogInfo rt_DataLoggingInfo;

      projetRobucar1103_M->rtwLogInfo = &rt_DataLoggingInfo;

      rtliSetLogFormat(projetRobucar1103_M->rtwLogInfo, 0);

      rtliSetLogMaxRows(projetRobucar1103_M->rtwLogInfo, 1000);

      rtliSetLogDecimation(projetRobucar1103_M->rtwLogInfo, 1);

      rtliSetLogVarNameModifier(projetRobucar1103_M->rtwLogInfo, "rt_");

      rtliSetLogT(projetRobucar1103_M->rtwLogInfo, "tout");

      rtliSetLogX(projetRobucar1103_M->rtwLogInfo, "");

      rtliSetLogXFinal(projetRobucar1103_M->rtwLogInfo, "");

      rtliSetSigLog(projetRobucar1103_M->rtwLogInfo, "");

      rtliSetLogXSignalInfo(projetRobucar1103_M->rtwLogInfo, NULL);

      rtliSetLogXSignalPtrs(projetRobucar1103_M->rtwLogInfo, NULL);

      rtliSetLogY(projetRobucar1103_M->rtwLogInfo, "");

      rtliSetLogYSignalInfo(projetRobucar1103_M->rtwLogInfo, NULL);

      rtliSetLogYSignalPtrs(projetRobucar1103_M->rtwLogInfo, NULL);
    }

    projetRobucar1103_M->solverInfoPtr = (&projetRobucar1103_M->solverInfo);
    projetRobucar1103_M->Timing.stepSize = (0.001);
    rtsiSetFixedStepSize(&projetRobucar1103_M->solverInfo, 0.001);
    rtsiSetSolverMode(&projetRobucar1103_M->solverInfo,
     SOLVER_MODE_SINGLETASKING);

    /* block I/O */
    projetRobucar1103_M->ModelData.blockIO = ((void *) &projetRobucar1103_B);

    (void) memset(((void *) &projetRobucar1103_B),0,
     sizeof(BlockIO_projetRobucar1103));

    {

      int_T i;
      void *pVoidBlockIORegion;

      pVoidBlockIORegion = (void *)(&projetRobucar1103_B.Switch);
      for (i = 0; i < 186; i++) {
        ((real_T*)pVoidBlockIORegion)[i] = 0.0;
      }

      pVoidBlockIORegion = (void *)(&projetRobucar1103_B.axe_x_Av);
      for (i = 0; i < 40; i++) {
        ((real_T*)pVoidBlockIORegion)[i] = 0.0;
      }
    }

    /* parameters */
    projetRobucar1103_M->ModelData.defaultParam = ((real_T *)
      &projetRobucar1103_P);
    /* states (continuous) */
    {
      real_T *x = (real_T *) &projetRobucar1103_X;
      projetRobucar1103_M->ModelData.contStates = (x);
      (void) memset((char_T *)x,0,
       sizeof(ContinuousStates_projetRobucar1));
    }

    /* states (dwork) */

    projetRobucar1103_M->Work.dwork = ((void *) &projetRobucar1103_DWork);

    (void) memset((char_T *) &projetRobucar1103_DWork,0,
     sizeof(D_Work_projetRobucar1103));
    {
      int_T i;
      real_T *dwork_ptr = (real_T *) &projetRobucar1103_DWork.position_verin_Av;

      for (i = 0; i < 8247; i++) {
        dwork_ptr[i] = 0.0;
      }
    }

    /* initialize non-finites */
    rt_InitInfAndNaN(sizeof(real_T));
  }
}

/* Model terminate function */

void projetRobucar1103_terminate(void)
{

  /* dSPACE I/O Board DS1103SER #1 Unit:GENSER Group:SETUP */
  dsser_disable(rtiDS1103SER_B1_Ser[0]);
  dsser_fifo_reset(rtiDS1103SER_B1_Ser[0]);

  /* dSPACE I/O Board DS1103 #1 Unit:PWM */
  ds1103_slave_dsp_pwm_output_set(0, SLVDSP1103_PWM_CH2_MSK,
   SLVDSP1103_PWM_TTL_HIGH);
  /* flag = UNDEF */
  slaveDSPPwmStopFlagCh2 = 2;

  /* dSPACE I/O Board DS1103 #1 Unit:PWM */
  ds1103_slave_dsp_pwm_output_set(0, SLVDSP1103_PWM_CH4_MSK,
   SLVDSP1103_PWM_TTL_LOW);
  /* flag = UNDEF */
  slaveDSPPwmStopFlagCh4 = 2;

  /* dSPACE RTICAN RX Message Block: "RX Message" Id:0 */
  {
    /* ... Set the message into sleep mode */
    while((rtican_ds1103_tq_error[0] =
      ds1103_can_msg_sleep(ds1103_msg_B1[DS1103_B1_C1_RX_STD_0X0])) ==
     DSMCOM_BUFFER_OVERFLOW);
  }
}

/*========================================================================*
 * Start of GRT compatible call interface                                 *
 *========================================================================*/

void MdlOutputs(int_T tid) {

  projetRobucar1103_output(tid);
}

void MdlUpdate(int_T tid) {

  projetRobucar1103_update(tid);
}

void MdlInitializeSizes(void) {
  projetRobucar1103_M->Sizes.numContStates = (10); /* Number of continuous states */
  projetRobucar1103_M->Sizes.numY = (0); /* Number of model outputs */
  projetRobucar1103_M->Sizes.numU = (0); /* Number of model inputs */
  projetRobucar1103_M->Sizes.sysDirFeedThru = (0); /* The model is not direct feedthrough */
  projetRobucar1103_M->Sizes.numSampTimes = (3); /* Number of sample times */
  projetRobucar1103_M->Sizes.numBlocks = (410); /* Number of blocks */
  projetRobucar1103_M->Sizes.numBlockIO = (240); /* Number of block outputs */
  projetRobucar1103_M->Sizes.numBlockPrms = (198); /* Sum of parameter "widths" */
}

void MdlInitializeSampleTimes(void) {
}

void MdlInitialize(void) {

  /* Derivative Block: '<S48>/Derivative' */
  projetRobucar1103_DWork.Derivative_RWORK.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative_RWORK.TimeStampB = rtInf;

  /* Derivative Block: '<S48>/Derivative1' */
  projetRobucar1103_DWork.Derivative1_RWORK.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative1_RWORK.TimeStampB = rtInf;

  /* Derivative Block: '<S48>/Derivative2' */
  projetRobucar1103_DWork.Derivative2_RWORK.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative2_RWORK.TimeStampB = rtInf;

  /* Derivative Block: '<S48>/Derivative3' */
  projetRobucar1103_DWork.Derivative3_RWORK.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative3_RWORK.TimeStampB = rtInf;

  /* TransferFcn Block: '<S37>/Integral' */
  projetRobucar1103_X.Integral_CSTATE = 0.0;

  /* Derivative Block: '<S37>/Derivative' */
  projetRobucar1103_DWork.Derivative_RWORK_c.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative_RWORK_c.TimeStampB = rtInf;

  /* TransferFcn Block: '<S38>/Integral' */
  projetRobucar1103_X.Integral_j_CSTATE = 0.0;

  /* Derivative Block: '<S38>/Derivative' */
  projetRobucar1103_DWork.Derivative_RWORK_i.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative_RWORK_i.TimeStampB = rtInf;

  /* Derivative Block: '<S62>/Derivative' */
  projetRobucar1103_DWork.Derivative_RWORK_g.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative_RWORK_g.TimeStampB = rtInf;

  /* TransferFcn Block: '<S62>/Integral' */
  projetRobucar1103_X.Integral_h_CSTATE = 0.0;

  /* Derivative Block: '<S59>/Derivative' */
  projetRobucar1103_DWork.Derivative_RWORK_f.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative_RWORK_f.TimeStampB = rtInf;

  /* TransferFcn Block: '<S59>/Integral' */
  projetRobucar1103_X.Integral_e_CSTATE = 0.0;

  /* Derivative Block: '<S60>/Derivative' */
  projetRobucar1103_DWork.Derivative_RWORK_d.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative_RWORK_d.TimeStampB = rtInf;

  /* TransferFcn Block: '<S60>/Integral' */
  projetRobucar1103_X.Integral_c_CSTATE = 0.0;

  /* Derivative Block: '<S61>/Derivative' */
  projetRobucar1103_DWork.Derivative_RWORK_j.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative_RWORK_j.TimeStampB = rtInf;

  /* TransferFcn Block: '<S61>/Integral' */
  projetRobucar1103_X.Integral_b_CSTATE = 0.0;

  /* Integrator Block: <S15>/Integrator */
  projetRobucar1103_X.Integrator_CSTATE = projetRobucar1103_P.Integrator_IC;

  /* TransferFcn Block: '<S5>/filtre1' */
  projetRobucar1103_X.filtre1_CSTATE = 0.0;

  /* TransferFcn Block: '<S5>/filtre' */
  projetRobucar1103_X.filtre_CSTATE = 0.0;

  /* Integrator Block: <S15>/Integrator1 */
  projetRobucar1103_X.Integrator1_CSTATE = projetRobucar1103_P.Integrator1_IC;

  /* Derivative Block: '<S14>/Derivative' */
  projetRobucar1103_DWork.Derivative_RWORK_p.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative_RWORK_p.TimeStampB = rtInf;

  /* Derivative Block: '<S14>/Derivative1' */
  projetRobucar1103_DWork.Derivative1_RWORK_b.TimeStampA = rtInf;
  projetRobucar1103_DWork.Derivative1_RWORK_b.TimeStampB = rtInf;
}

void MdlStart(void) {

  /* Start for DataStoreMemory: '<S26>/Data Store Memory' */
  projetRobucar1103_DWork.position_verin_Av =
    projetRobucar1103_P.DataStoreMemory_InitialV;

  /* Start for DataStoreMemory: '<S26>/Data Store Memory1' */
  projetRobucar1103_DWork.position_verin_Ar =
    projetRobucar1103_P.DataStoreMemory1_Initi_l;

  /* TransportDelay Block: '<S35>/Transport Delay' */
  {
    real_T *pBuffer =
      &projetRobucar1103_DWork.TransportDelay_RWORK.TUbufferArea[0];

    projetRobucar1103_DWork.TransportDelay_IWORK.Tail = 0;
    projetRobucar1103_DWork.TransportDelay_IWORK.Head = 0;
    projetRobucar1103_DWork.TransportDelay_IWORK.Last = 0;
    projetRobucar1103_DWork.TransportDelay_IWORK.CircularBufSize = 1024;
    pBuffer[0] = projetRobucar1103_P.TransportDelay_InitOutput;
    pBuffer[1024] = projetRobucar1103_M->Timing.t[0];
    projetRobucar1103_DWork.TransportDelay_PWORK.TUbufferPtrs[0] = (void *)
      &pBuffer[0];
    projetRobucar1103_DWork.TransportDelay_PWORK.TUbufferPtrs[1] = (void *)
      &pBuffer[1024];
  }

  /* TransportDelay Block: '<S35>/Transport Delay1' */
  {
    real_T *pBuffer =
      &projetRobucar1103_DWork.TransportDelay1_RWORK.TUbufferArea[0];

    projetRobucar1103_DWork.TransportDelay1_IWORK.Tail = 0;
    projetRobucar1103_DWork.TransportDelay1_IWORK.Head = 0;
    projetRobucar1103_DWork.TransportDelay1_IWORK.Last = 0;
    projetRobucar1103_DWork.TransportDelay1_IWORK.CircularBufSize = 1024;
    pBuffer[0] = projetRobucar1103_P.TransportDelay1_InitOutpu;
    pBuffer[1024] = projetRobucar1103_M->Timing.t[0];
    projetRobucar1103_DWork.TransportDelay1_PWORK.TUbufferPtrs[0] = (void *)
      &pBuffer[0];
    projetRobucar1103_DWork.TransportDelay1_PWORK.TUbufferPtrs[1] = (void *)
      &pBuffer[1024];
  }

  /* TransportDelay Block: '<S36>/Transport Delay' */
  {
    real_T *pBuffer =
      &projetRobucar1103_DWork.TransportDelay_RWORK_g.TUbufferArea[0];

    projetRobucar1103_DWork.TransportDelay_IWORK_n.Tail = 0;
    projetRobucar1103_DWork.TransportDelay_IWORK_n.Head = 0;
    projetRobucar1103_DWork.TransportDelay_IWORK_n.Last = 0;
    projetRobucar1103_DWork.TransportDelay_IWORK_n.CircularBufSize = 1024;
    pBuffer[0] = projetRobucar1103_P.TransportDelay_InitOutp_p;
    pBuffer[1024] = projetRobucar1103_M->Timing.t[0];
    projetRobucar1103_DWork.TransportDelay_PWORK_c.TUbufferPtrs[0] = (void *)
      &pBuffer[0];
    projetRobucar1103_DWork.TransportDelay_PWORK_c.TUbufferPtrs[1] = (void *)
      &pBuffer[1024];
  }

  /* TransportDelay Block: '<S36>/Transport Delay1' */
  {
    real_T *pBuffer =
      &projetRobucar1103_DWork.TransportDelay1_RWORK_j.TUbufferArea[0];

    projetRobucar1103_DWork.TransportDelay1_IWORK_k.Tail = 0;
    projetRobucar1103_DWork.TransportDelay1_IWORK_k.Head = 0;
    projetRobucar1103_DWork.TransportDelay1_IWORK_k.Last = 0;
    projetRobucar1103_DWork.TransportDelay1_IWORK_k.CircularBufSize = 1024;
    pBuffer[0] = projetRobucar1103_P.TransportDelay1_InitOut_e;
    pBuffer[1024] = projetRobucar1103_M->Timing.t[0];
    projetRobucar1103_DWork.TransportDelay1_PWORK_a.TUbufferPtrs[0] = (void *)
      &pBuffer[0];
    projetRobucar1103_DWork.TransportDelay1_PWORK_a.TUbufferPtrs[1] = (void *)
      &pBuffer[1024];
  }

  /* dSPACE I/O Board DS1103 #1 Unit:PWM */
  projetRobucar1103_DWork.SFunction2_IWORK[1] = 0;

  /* dSPACE I/O Board DS1103 #1 Unit:PWM */
  projetRobucar1103_DWork.SFunction4_IWORK[3] = 0;

  /* Start for DataStoreMemory: '<S8>/Data Store Memory' */
  projetRobucar1103_DWork.consigne =
    projetRobucar1103_P.DataStoreMemory_Initia_i;

  /* Start for DataStoreMemory: '<S8>/Data Store Memory1' */
  projetRobucar1103_DWork.pedal_frein =
    projetRobucar1103_P.DataStoreMemory1_Initial;

  /* Start for DataStoreMemory: '<S8>/Data Store Memory2' */
  projetRobucar1103_DWork.marche_arriere =
    projetRobucar1103_P.DataStoreMemory2_Initial;

  /* Integrator Block: <S15>/Integrator */
  (void) memcpy(&projetRobucar1103_B.Ie,&projetRobucar1103_P.Integrator_IC,
   1 * sizeof(real_T));

  /* Integrator Block: <S15>/Integrator1 */
  (void)
  memcpy(&projetRobucar1103_B.vitessemoteur,&projetRobucar1103_P.Integrator1_IC,
   1 * sizeof(real_T));

  /* RandomNumber Block: '<S17>/White Noise' */
  {
    uint32_T *RandSeed = (uint32_T *)
      &projetRobucar1103_DWork.WhiteNoise_IWORK.RandSeed;
    uint32_T r, t;
    *RandSeed = (uint32_T)projetRobucar1103_P.WhiteNoise_Seed;
    r = *RandSeed >> 16;
    t = *RandSeed & RT_BIT16;
    *RandSeed = ((*RandSeed - (r << 16) - t) << 16) + t + r;
    if (*RandSeed < 1) {
      *RandSeed = SEED0;
    }
    if (*RandSeed > MAXSEED) {
      *RandSeed = MAXSEED;
    }

    projetRobucar1103_DWork.WhiteNoise_RWORK.NextOutput =
      rt_NormalRand(RandSeed++) * projetRobucar1103_P.WhiteNoise_StdDev +
      projetRobucar1103_P.WhiteNoise_Mean;
  }

  /* RandomNumber Block: '<S16>/White Noise' */
  {
    uint32_T *RandSeed = (uint32_T *)
      &projetRobucar1103_DWork.WhiteNoise_IWORK_g.RandSeed;
    uint32_T r, t;
    *RandSeed = (uint32_T)projetRobucar1103_P.WhiteNoise_Seed_j;
    r = *RandSeed >> 16;
    t = *RandSeed & RT_BIT16;
    *RandSeed = ((*RandSeed - (r << 16) - t) << 16) + t + r;
    if (*RandSeed < 1) {
      *RandSeed = SEED0;
    }
    if (*RandSeed > MAXSEED) {
      *RandSeed = MAXSEED;
    }

    projetRobucar1103_DWork.WhiteNoise_RWORK_f.NextOutput =
      rt_NormalRand(RandSeed++) * projetRobucar1103_P.WhiteNoise_StdDev_p +
      projetRobucar1103_P.WhiteNoise_Mean_d;
  }

  /* RandomNumber Block: '<S18>/White Noise' */
  {
    uint32_T *RandSeed = (uint32_T *)
      &projetRobucar1103_DWork.WhiteNoise_IWORK_f.RandSeed;
    uint32_T r, t;
    *RandSeed = (uint32_T)projetRobucar1103_P.WhiteNoise_Seed_e;
    r = *RandSeed >> 16;
    t = *RandSeed & RT_BIT16;
    *RandSeed = ((*RandSeed - (r << 16) - t) << 16) + t + r;
    if (*RandSeed < 1) {
      *RandSeed = SEED0;
    }
    if (*RandSeed > MAXSEED) {
      *RandSeed = MAXSEED;
    }

    projetRobucar1103_DWork.WhiteNoise_RWORK_h.NextOutput =
      rt_NormalRand(RandSeed++) * projetRobucar1103_P.WhiteNoise_StdDev_p5 +
      projetRobucar1103_P.WhiteNoise_Mean_m;
  }

  MdlInitialize();
}

RT_MODEL_projetRobucar1103 *projetRobucar1103(void) {
  projetRobucar1103_initialize(1);
  return projetRobucar1103_M;
}

void MdlTerminate(void) {
  projetRobucar1103_terminate();
}

/*========================================================================*
 * End of GRT compatible call interface                                   *
 *========================================================================*/

