/*********************** dSPACE target specific file *************************
   
   Include file projetRobucar1103_rti.c:
   
   Definition of functions and variables for the system I/O and for
   the hardware and software interrupts used.
   
   RTI1103 5.3.6 (29-May-2006)
   Mon Feb 18 20:07:47 2013
   
   Copyright (c) 1997-2004 dSPACE GmbH, GERMANY
   
 *****************************************************************************/

#if !(defined(__RTI_SIMENGINE__) || defined(RTIMP_FRAME))
# error This file may be included only by the RTI(-MP) simulation engine.
#endif

/* Include the model header file. */
#include "projetRobucar1103.h"
#include "projetRobucar1103_private.h"

/* Defines for block output and parameter structure existence */
#define RTI_rtB_STRUCTURE_EXISTS        1
#define RTI_rtP_STRUCTURE_EXISTS        1
#define RTB_STRUCTURE_NAME              projetRobucar1103_B
#define RTP_STRUCTURE_NAME              projetRobucar1103_P

/* Global pointers to data type transitions (for TRC-file access) */
volatile real_T *p_projetRobucar1103_B_real_T_0 = &projetRobucar1103_B.Switch;
volatile int32_T *p_projetRobucar1103_B_int32_T_1 =
  &projetRobucar1103_B.SFunction1_o3_f;
volatile uint32_T *p_projetRobucar1103_B_uint32_T_2 =
  &projetRobucar1103_B.SFunction1_o2_g;
volatile uint16_T *p_projetRobucar1103_B_uint16_T_3 =
  &projetRobucar1103_B.Gain_j;
volatile uint8_T *p_projetRobucar1103_B_uint8_T_4 =
  &projetRobucar1103_B.SFunction1_o1_g[0];
volatile boolean_T *p_projetRobucar1103_B_boolean_T_5 =
  &projetRobucar1103_B.Switch1_l;
volatile real_T *p_projetRobucar1103_P_real_T_0 =
  &projetRobucar1103_P.centrale_inertie_Value;
volatile uint32_T *p_projetRobucar1103_P_uint32_T_1 =
  &projetRobucar1103_P.nombrebyte_Value;
volatile uint16_T *p_projetRobucar1103_P_uint16_T_2 =
  &projetRobucar1103_P.DataStoreMemory1_Initi_l;
volatile uint8_T *p_projetRobucar1103_P_uint8_T_3 =
  &projetRobucar1103_P.Switch_Threshold_m;
volatile boolean_T *p_projetRobucar1103_P_boolean_T_4 =
  &projetRobucar1103_P.bin1_Value;
volatile uint8_T *p_projetRobucar1103_P_uint8_T_5 =
  &projetRobucar1103_P.Gain_Gain_d;
volatile real_T *p_projetRobucar1103_DWork_real_T_0 =
  &projetRobucar1103_DWork.position_verin_Av;
volatile int_T *p_projetRobucar1103_DWork_int_T_2 =
  &projetRobucar1103_DWork.TransportDelay_IWORK.Tail;
volatile uint16_T *p_projetRobucar1103_DWork_uint16_T_3 =
  &projetRobucar1103_DWork.position_verin_Ar;
volatile real_T *p_projetRobucar1103_X_real_T_0 =
  &projetRobucar1103_X.Integral_CSTATE;

/* dSPACE generated includes for header files */
#include <brtenv.h>
#include <rtkernel.h>
#include <rti_assert.h>
#include <rtidefineddatatypes.h>
#include <dsser.h>
#include <def1103.h>
#include <slvdsp1103.h>
#include <rti_slv1103.h>
#include <rtican_ds1103.h>

/****** Definitions: task functions for timer tasks *********************/

/* Timer Task 1. (Base rate). */
static void rti_TIMERA(rtk_p_task_control_block task) {
  /* Task entry code BEGIN */
  /* -- None. -- */
  /* Task entry code END */

  /* Task code. */
  baseRateService(task);

  /* Task exit code BEGIN */
  /* -- None. -- */
  /* Task exit code END */
}

/* ===== Declarations of RTI blocks ======================================== */

/* dSPACE I/O Board DS1103SER #1 Unit:GENSER Group:SETUP */
dsserChannel *rtiDS1103SER_B1_Ser[1];

/* flag = UNDEF */
int slaveDSPPwmStopFlagCh2 = 2;

/* flag = UNDEF */
int slaveDSPPwmStopFlagCh4 = 2;

/* dSPACE Test-Automation Stimulus Engine */
#define TA_STIMULUS_ENGINE_ENABLE       0

/* dSPACE I/O Board DS1103_RTICAN #1 */

/* ...  definition of channel struct */
ds1103_canChannel* ds1103_channel_B1_C1;

/* declare pointers to CAN message structures for support of TX-Custom code */
ds1103_canMsg* DS1103_TX_SPMSG_B1_C1_STD;
ds1103_canMsg* DS1103_TX_SPMSG_B1_C1_XTD;

/* ... definition of message variable for the RTICAN blocks */
ds1103_canMsg* ds1103_msg_B1[DS1103_B1_NUMMSG];

/* dSPACE I/O Board RTICAN_GLOBAL #0 */

/* This is the global time_sync_flag */
UInt32 rtican_time_sync_flag = 0;

/* ===== Definition of interface functions for simulation engine =========== */

#ifdef MULTITASKING
# define dsIsSampleHit(RTM,sti) rtmGetSampleHitPtr(RTM)[sti]
#else
# define dsIsSampleHit(RTM,sti) rtmIsSampleHit(RTM,sti,0)
#endif

#if defined(_INLINE)
# define __INLINE static inline
#else
# define __INLINE static
#endif

static void rti_mdl_initialize_host_services(void)
{
  {
    ts_timestamp_type ts = {0,0};

    host_service(1, &ts);
  }
}

static void rti_mdl_initialize_io_boards(void)
{
  /* Registering of RTI products and modules at VCM */
  {
    vcm_module_register(VCM_MID_RTI1103, (void *) 0,
     VCM_TXT_RTI1103, 5, 3, 6,
     VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);

    {
      vcm_module_descriptor_type* msg_mod_ptr;

      msg_mod_ptr = vcm_module_register(VCM_MID_MATLAB, (void *) 0,
       VCM_TXT_MATLAB, 7, 2, 0,
       VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);
      vcm_module_register(VCM_MID_SIMULINK, msg_mod_ptr,
       VCM_TXT_SIMULINK, 6, 4, 0,
       VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);
      vcm_module_register(VCM_MID_RTW, msg_mod_ptr,
       VCM_TXT_RTW, 6, 4, 0,
       VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);
      vcm_module_register(VCM_MID_STATEFLOW, msg_mod_ptr,
       VCM_TXT_STATEFLOW, 0, 0, 0,
       VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);
      vcm_module_register(VCM_MID_STATEFLOW_CODER, msg_mod_ptr,
       VCM_TXT_STATEFLOW_CODER, 0, 0, 0,
       VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);
    }
    vcm_module_register(VCM_MID_RTICAN, (void *) 0,
     VCM_TXT_RTICAN, 2, 6, 0,
     VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);
  }

  /* dSPACE I/O Board DS1103SER #1 Unit:GENSER Group:SETUP */
  rtiDS1103SER_B1_Ser[0] =dsser_init(DSSER_ONBOARD,0,64);
  dsser_config(rtiDS1103SER_B1_Ser[0],2, 9600, 8,
   DSSER_1_STOPBIT,DSSER_NO_PARITY, DSSER_14_BYTE_TRIGGER_LEVEL,0, (DSSER_RS232
    | DSSER_AUTOFLOW_DISABLE));

  /* dSPACE I/O Board DS1103 #1 */
  /* Initialize master - slave DSP communication */
  ds1103_slave_dsp_communication_init();

  /* Initialize automatic index generation */
  rti_slv1103_init_fcn_index();

  /* Initialize slave DSP error level */
  rti_slv1103_error_level = 0;

  ds1103_slave_dsp_pwm_init(0, 1.0/ 10000, 0.5, SLVDSP1103_PWM_MODE_SYM,
   SLVDSP1103_PWM_POL_HIGH, SLVDSP1103_PWM_CH2_MSK);
  ds1103_slave_dsp_pwm_output_set(0, SLVDSP1103_PWM_CH2_MSK,
   SLVDSP1103_PWM_TTL_LOW);

  ds1103_slave_dsp_pwm_duty_write_register(0, &rti_slv1103_fcn_index[7], 2);

  ds1103_slave_dsp_pwm_init(0, 1.0/ 10000, 0.5, SLVDSP1103_PWM_MODE_SYM,
   SLVDSP1103_PWM_POL_HIGH, SLVDSP1103_PWM_CH4_MSK);
  ds1103_slave_dsp_pwm_output_set(0, SLVDSP1103_PWM_CH4_MSK,
   SLVDSP1103_PWM_TTL_LOW);

  ds1103_slave_dsp_pwm_duty_write_register(0, &rti_slv1103_fcn_index[9], 4);

  /* dSPACE I/O Board DS1103 #1 Unit:ENC_SETUP */
  ds1103_inc_init(1, DS1103_INC_CH1_TTL);

  ds1103_inc_init(2, DS1103_INC_CH2_TTL);

  ds1103_inc_init(3, DS1103_INC_CH3_TTL);

  ds1103_inc_init(4, DS1103_INC_CH4_TTL);

  ds1103_inc_init(5, DS1103_INC_CH5_TTL);

  ds1103_inc_init(6, DS1103_INC_CH6_TTL|DS1103_INC_CH6_16BIT);

  ds1103_inc_init(7, DS1103_INC_CH7_VPP|DS1103_INC_CH7_38BIT);

  /* dSPACE I/O Board DS1103_RTICAN #1 */

  /* dSPACE RTICAN MASTER SETUP Block */
  /* ... Initialize the CAN communication: 250 kbit/s */
  ds1103_can_channel_init_advanced(20000000, 0x81, 0x2F, DS1103_CAN_INT_ENABLE,
   DS1103_CAN_STD, DS1103_CAN_NO_SUBINT);

  /* ... Initialize TX message structs for custom code  */
  DS1103_TX_SPMSG_B1_C1_STD = ds1103_can_msg_tx_register(
    3, 1050, DS1103_CAN_STD, DS1103_CAN_TIMECOUNT_INFO |
   DS1103_CAN_DELAYCOUNT_INFO | DS1103_CAN_MSG_INFO, DS1103_CAN_NO_SUBINT, 0,
   DS1103_CAN_TRIGGER_MSG, DS1103_CAN_TIMEOUT_NORMAL);

  DS1103_TX_SPMSG_B1_C1_XTD = ds1103_can_msg_tx_register(
    3, 1100, DS1103_CAN_EXT, DS1103_CAN_TIMECOUNT_INFO |
   DS1103_CAN_DELAYCOUNT_INFO | DS1103_CAN_MSG_INFO, DS1103_CAN_NO_SUBINT, 0,
   DS1103_CAN_TRIGGER_MSG, DS1103_CAN_TIMEOUT_NORMAL);

  /* dSPACE RTICAN RX Message Block: "RX Message" Id:0 */
  /* ... Register message */
  ds1103_msg_B1[DS1103_B1_C1_RX_STD_0X0] = ds1103_can_msg_rx_register(0, 0,
   DS1103_CAN_STD,
   (DS1103_CAN_DATA_INFO|DS1103_CAN_DATA_INFO|DS1103_CAN_TIMECOUNT_INFO|DS1103_CAN_TIMECOUNT_INFO),
   DS1103_CAN_NO_SUBINT);

  /* dSPACE RTICAN RX Message Block: "RX Message" Id:0 */
  projetRobucar1103_B.SFunction1_o5 = 0; /* processed - flag */
  projetRobucar1103_B.SFunction1_o6 = 0; /* timestamp */
  projetRobucar1103_B.SFunction1_o7 = 0; /* deltatime */

  /* dSPACE I/O Board RTICAN_GLOBAL #0 */

  /* Initialization of Master ADC units */
  ds1103_adc_trigger_setup(5, DS1103_TRIGGER_DISABLE);
  ds1103_adc_trigger_setup(6, DS1103_TRIGGER_DISABLE);
  ds1103_adc_trigger_setup(7, DS1103_TRIGGER_DISABLE);
  ds1103_adc_trigger_setup(8, DS1103_TRIGGER_DISABLE);

  /* Initialization of Master MUXADC units */
  /* Initialization of Master DAC units */
  ds1103_dac_init(DS1103_DACMODE_TRANSPARENT);
  ds1103_dac_trigger_setup(DS1103_TRIGGER_DISABLE);

  /* Initialization of Master EncSetup units  */
  ds1103_inc_trigger_setup(1,DS1103_TRIGGER_DISABLE);
  ds1103_inc_trigger_setup(2,DS1103_TRIGGER_DISABLE);
  ds1103_inc_trigger_setup(3,DS1103_TRIGGER_DISABLE);
  ds1103_inc_trigger_setup(4,DS1103_TRIGGER_DISABLE);
  ds1103_inc_trigger_setup(5,DS1103_TRIGGER_DISABLE);
  ds1103_inc_trigger_setup(6,DS1103_TRIGGER_DISABLE);
  ds1103_inc_trigger_setup(7,DS1103_TRIGGER_DISABLE);
}

/* Function rti_mdl_slave_load() is empty */
#define rti_mdl_slave_load()

/* Function rti_mdl_rtk_initialize() is empty */
#define rti_mdl_rtk_initialize()

static void rti_mdl_initialize_io_units(void)
{
  /* dSPACE I/O Board DS1103 #1 Unit:ENC_POS */
  ds1103_inc_position_write(2, 0, DS1103_INC_LINE_SUBDIV_4);

  ds1103_inc_position_write(1, 0, DS1103_INC_LINE_SUBDIV_4);

  ds1103_inc_position_write(4, 0, DS1103_INC_LINE_SUBDIV_4);

  ds1103_inc_position_write(3, 0, DS1103_INC_LINE_SUBDIV_4);

  /* dSPACE I/O Board DS1103 #1 Unit:BIT_IO */
  ds1103_bit_io_init(DS1103_DIO1_OUT);

  /* dSPACE I/O Board DS1103 #1 Unit:BIT_IO Group:BIT_OUT */
  ds1103_bit_io_set(DS1103_DIO0_SET|DS1103_DIO0_SET|DS1103_DIO1_SET);
  ds1103_bit_io_clear(DS1103_DIO4_CLEAR|DS1103_DIO5_CLEAR);
  /* dSPACE I/O Board DS1103 #1 Unit:PWM */
  ds1103_slave_dsp_pwm_output_set(0, SLVDSP1103_PWM_CH2_MSK,
   SLVDSP1103_PWM_TTL_LOW);

  /* flag = UNDEF */
  slaveDSPPwmStopFlagCh2 = 2;

  ds1103_slave_dsp_pwm_output_set(0, SLVDSP1103_PWM_CH4_MSK,
   SLVDSP1103_PWM_TTL_LOW);

  /* flag = UNDEF */
  slaveDSPPwmStopFlagCh4 = 2;

  /* dSPACE I/O Board DS1103 #1 Unit:DAC */
  ds1103_dac_write(5, 0);

  ds1103_dac_write(6, 0);

  ds1103_dac_write(1, 0);

  ds1103_dac_write(2, 0);

  /* dSPACE I/O Board DS1103SER #1 Unit:GENSER Group:SETUP */
  dsser_enable(rtiDS1103SER_B1_Ser[0]);

  /* dSPACE I/O Board DS1103_RTICAN #1 */
  /* Start CAN controller */
  ds1103_can_channel_start(DS1103_CAN_INT_DISABLE);

  /* Set the DS1103 CAN error level */
  rtican_ds1103_error_level = 0;
  /* ... Reset all taskqueue-specific error variables */
  rtican_ds1103_tq_err_all_reset();
  /* ... Clear all message data buffers */
  ds1103_can_all_data_clear();

  {
    static UInt32 numInit = 0;
    if (numInit != 0)
    {
      /* ... Wake message up */
      while((rtican_ds1103_tq_error[0] =
        ds1103_can_msg_wakeup(ds1103_msg_B1[DS1103_B1_C1_RX_STD_0X0]))==
       DSMCOM_BUFFER_OVERFLOW);
    }
    ++numInit;
  }
}

/* Function rti_mdl_acknowledge_interrupts() is empty */
#define rti_mdl_acknowledge_interrupts()

/* Function rti_mdl_timetables_register() is empty */
#define rti_mdl_timetables_register()

static void rti_mdl_timesync_simstate(void)
{

  /* ...... initiate single synchronisation after SIMSTATE changing */
  rtican_time_sync_flag = 0;
}

static void rti_mdl_timesync_baserate(void)
{

  {
    /* ...... Model has timer-driven task(s) -> perform periodic resynchronisation */
    if (!rtican_time_sync_flag --)
    {
      ds1103_can_timecount_set(rtmGetT(RTM));
      rtican_time_sync_flag = 10000;
    }
  }
}

static void rti_mdl_background(void)
{
  /* dSPACE I/O Board DS1103 #1 */
  /* Check master - slave dsp communication */
  rti_slv1103_taskqueue_error_all_check();

  /* dSPACE I/O Board DS1103_RTICAN #1 */
  {
    real_T bg_code_exec_time;
    static real_T bg_code_last_exec_time = 0.0;

    bg_code_exec_time = RTLIB_TIC_READ();
    if ( (bg_code_exec_time - bg_code_last_exec_time) > 0.25 ||
     (bg_code_exec_time - bg_code_last_exec_time) < 0){
      /* ... Check taskqueue-specific error variables */
      rtican_ds1103_tq_err_all_chk();

      bg_code_last_exec_time = bg_code_exec_time;
    }
  }

  /* copy DPMEM - buffers in background */
  {
    /* call update function for DS1103 CAN interface */
    ds1103_can_msg_copy_all_to_mem();
  }
}

__INLINE void rti_mdl_sample_input(void)
{
  /* Calls for base sample time: [0.001, 0] */
  /* dSPACE I/O Board DS1103SER #1 Unit:GENSER Group:RECEIVE */
  {
    UInt32 rxFifoLevel;
    UInt32 bytesRefNumOf;
    bytesRefNumOf = (projetRobucar1103_P.nombrebyte_Value <= 2) ?
      projetRobucar1103_P.nombrebyte_Value : 2;
    rxFifoLevel = dsser_receive_fifo_level(rtiDS1103SER_B1_Ser[0]);
    if (rxFifoLevel >= bytesRefNumOf)
    {
      projetRobucar1103_B.SFunction1_o3_f =
      dsser_receive(rtiDS1103SER_B1_Ser[0], bytesRefNumOf, (UInt8 *)
       projetRobucar1103_B.SFunction1_o1_g, (UInt32 *)
       &projetRobucar1103_B.SFunction1_o2_g);
    }
    else
    {
      UInt32 *temp = (UInt32 *) &projetRobucar1103_B.SFunction1_o2_g;
      *temp = 0;
      projetRobucar1103_B.SFunction1_o3_f = DSSER_NO_DATA;
    }
  }

  /* dSPACE I/O Board DS1103_RTICAN #1 Unit:DEFAULT */
  /* call update function for DS1103 CAN interface */
  ds1103_can_msg_copy_all_to_mem();

  /* dSPACE I/O Board DS1103 #1 Unit:MultiAdc */
  {
    Float64 pvalues[20];

    ds1103_adc_multi_conv_read(DS1103_ADC_CHANNEL5|DS1103_ADC_CHANNEL6|DS1103_ADC_CHANNEL7|DS1103_ADC_CHANNEL8|DS1103_ADC_CHANNEL1|DS1103_ADC_CHANNEL2|DS1103_ADC_CHANNEL3|DS1103_ADC_CHANNEL4|DS1103_ADC_CHANNEL20|DS1103_ADC_CHANNEL19|DS1103_ADC_CHANNEL18|DS1103_ADC_CHANNEL17,
     pvalues);
    projetRobucar1103_B.SFunction_j[0] = pvalues[4];
    projetRobucar1103_B.SFunction_j[1] = pvalues[5];
    projetRobucar1103_B.SFunction_j[2] = pvalues[6];
    projetRobucar1103_B.SFunction_j[3] = pvalues[7];
    projetRobucar1103_B.SFunction_d[0] = pvalues[0];
    projetRobucar1103_B.SFunction_d[1] = pvalues[1];
    projetRobucar1103_B.SFunction_d[2] = pvalues[2];
    projetRobucar1103_B.SFunction_d[3] = pvalues[3];
    projetRobucar1103_B.SFunction_a = pvalues[19];
    projetRobucar1103_B.SFunction_i = pvalues[18];
    projetRobucar1103_B.SFunction_o = pvalues[17];
    projetRobucar1103_B.SFunction = pvalues[16];
  }
  /* dSPACE I/O Board DS1103 #1 Unit:ENC_POS Group:POS */
  projetRobucar1103_B.SFunction1 = (real_T) ds1103_inc_position_read(2,
   DS1103_INC_LINE_SUBDIV_4);

  projetRobucar1103_B.SFunction1_d = (real_T) ds1103_inc_position_read(1,
   DS1103_INC_LINE_SUBDIV_4);

  projetRobucar1103_B.SFunction1_g = (real_T) ds1103_inc_position_read(4,
   DS1103_INC_LINE_SUBDIV_4);

  projetRobucar1103_B.SFunction1_o = (real_T) ds1103_inc_position_read(3,
   DS1103_INC_LINE_SUBDIV_4);

  /* dSPACE I/O Board DS1103 #1 Unit:ENC_POS Group:DPOS */
  projetRobucar1103_B.SFunction2 = (real_T) ds1103_inc_delta_position_read(2,
   DS1103_INC_LINE_SUBDIV_4);

  projetRobucar1103_B.SFunction2_f = (real_T) ds1103_inc_delta_position_read(1,
   DS1103_INC_LINE_SUBDIV_4);

  projetRobucar1103_B.SFunction2_b = (real_T) ds1103_inc_delta_position_read(4,
   DS1103_INC_LINE_SUBDIV_4);

  projetRobucar1103_B.SFunction2_k = (real_T) ds1103_inc_delta_position_read(3,
   DS1103_INC_LINE_SUBDIV_4);
}

#undef __INLINE

/****** [EOF] ****************************************************************/
